 /*   ACID FLIGHT
    Copyright (C) 2021, Valentin Janocha

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.

*/
#include <iostream>
#include "SDL2/SDL.h"
#include "SDL2/SDL_image.h"
#include "SDL2/SDL_ttf.h"
#include "SDL2/SDL_mixer.h"
#include "SDL2/SDL_thread.h"
#include <stdlib.h>
#include <fstream>
#include <math.h>
#include <time.h>
#include <string>
#include <sstream> 
#define Maximum(a, b) ((a > b) ? a : b)
#define Minimum(a, b) ((a < b) ? a : b)


SDL_DisplayMode DMode;
SDL_Window* Window = NULL;
SDL_Renderer* Renderer = NULL; //mystic thing, brings an image to the screen
SDL_Surface* CurrentSurface = NULL;
SDL_Surface* ScreenSurface = NULL; 
SDL_Rect Reader;
SDL_Rect Writer;
SDL_Event event;
TTF_Font *gFont[5];
int FullScreen=true;
bool AntiA=true;
bool running=true;
bool Mono=false;


SDL_GameController *controller;
SDL_Texture* Images[800];
SDL_Surface* ImageC[800];

int texturesUsed=0;

std::string speicher;

float CamX=0;
float CamY=0;
int TowerHeight=0;
int floorC=0;
float Scroller=0;
int maxL=6;
int minL=6;
int maxD=2;
int lastS=4;
bool Walled=true;
int Score=0;

int BGR=200;
int BGG=200;
int BGB=200;

int ABGR;
int ABGG;
int ABGB;

int Difficulty=1;
int MusicVol=12;
int SoundVol=12;
int CMode=0;
bool InputDef=false;
int InN=1;
std::string strin;
bool GameOver=false;

int RunMode=10;
int mSelect=1;
SDL_Texture *FTex[25];
SDL_Color FontC={0, 0, 0};
SDL_Color FontR={255, 0, 0};
const int StackSize=3000;
bool Keylock=true;
int DZone=10000;
int ScorePlace=0;
SDL_GameControllerButton ControllerButton1=SDL_CONTROLLER_BUTTON_A;
SDL_GameControllerButton ControllerButton2=SDL_CONTROLLER_BUTTON_START;
Mix_Music *Music[30]; 
Mix_Chunk *Sounds [5];
SDL_Texture* re;

int cSong=0;
float cVolume=0;
bool NoFun=false;

int TimeIn=0;

int Recoulor(SDL_Surface* Surf, int r, int g, int b, SDL_Texture** give, bool clean=true)	//this is crazy!
{

	
	 SDL_LockSurface(Surf);
    int bpp = Surf->format->BytesPerPixel;
    int x1=Surf->w;
    int y1=Surf->h;
    
   

	
    for(int x=0; x<x1; x++)
    for(int y=0; y<y1; y++)
    {
    Uint8* p = (Uint8*)Surf->pixels + y * Surf->pitch + x * bpp;
    Uint32 pixelColor;
    switch(bpp)
    {
        case(1):
            pixelColor = *p;
            break;
        case(2):
            pixelColor = *(Uint16*)p;
            break;
        case(3):
            if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
                pixelColor = p[0] << 16 | p[1] << 8 | p[2];
            else
                pixelColor = p[0] | p[1] << 8 | p[2] << 16;
            break;
        case(4):
            pixelColor = *(Uint32*)p;
            break;
    }
    Uint8 red, green, blue, alpha;
    SDL_GetRGBA(pixelColor, Surf->format, &red, &green, &blue, &alpha);
    if(alpha>125)
    {
    SDL_Rect recto;
    recto.x=x;
    recto.y=y;
    recto.w=1;
    recto.h=1;
    SDL_FillRect(Surf, &recto, SDL_MapRGB(Surf->format, r, g, b));
	}
	}
	SDL_UnlockSurface(Surf);
	if(clean==true)
	if((*give)!=NULL)SDL_DestroyTexture(*give);
	(*give)=SDL_CreateTextureFromSurface(Renderer, Surf);
	
	
	
	
}

class BGObject
{
	public:
	 float X=0;
	 float Y=0;
	 int h=0;
	 int w=0;
	 float cRot=0;
	 float Rot=0;
	 int Sprite=0;
	 int Frames=0;
	 int cFrame=0;
	 int FrameWait=0;
	 int FrameCounter=0;
	 SDL_RendererFlip Flipped=SDL_FLIP_NONE;
	 float ZoomPT=0;
	 float Zoomed=0;
	 int Lifetime=0;
	 float Speed=0;
	 float Angle;
	 float Alpha=255;
	 float Alpharise=0;
	 bool CamMove=false;
	 int DarkerThanBG=0;
	 int maxX=0;
	 int minX=0;
	 bool NoReco=false;
	 int Layer=1;
	 
	 	 int Framing()  //Animation
		 {
			if(Frames>0)
		  {
			 
			if(FrameCounter>=FrameWait)
			{
				
				cFrame++;
				FrameCounter=0;
				if(cFrame>Frames)cFrame=0;
			}
			else
			{
				FrameCounter++;
			}
		}
		}
		
		int Move()
		{
		if(Speed!=0)
		{
		float cAngle=((Angle*M_PI)/180);
			X=X+(cos(cAngle)*Speed);
			Y=Y+(sin(cAngle)*Speed);
			
			if(X<minX && minX!=0)X=1920+100;
			if(X>maxX && maxX!=0)X=-1000;
		}
		}
		
	int RoZo()
		{
		if(Rot!=0)
		{
			cRot=cRot+Rot;
		}
		}
		
		int Draw(SDL_Renderer* Rend)
		{
		if(Sprite!=0 || DarkerThanBG!=0)
		{
	    SDL_Rect Re, Wri;
		Re.x=(cFrame*w)+1; //Fix for the Artefacts. Remove +1 maybe?
		Re.y=0;
		Re.h=h;
		Re.w=w-2; //Fix for the Artefacts. Remove -2 maybe?
		if(Zoomed==0)
		{
		Wri.x=X;
		Wri.y=Y;
		Wri.h=h;
		Wri.w=w;
		}
		else
		{
		Wri.x=X-(((w*Zoomed)-w)/2);
		Wri.y=Y-(((h*Zoomed)-h)/2);
		Wri.h=h*Zoomed;
		Wri.w=w*Zoomed;
		}
		if(CamMove==true)
		{
			Wri.x=Wri.x-CamX;
			Wri.y=Wri.y-CamY;
		}
		if(DarkerThanBG==0)
		{
		if(NoReco==false)
		{
			
		SDL_Texture* tex;
		Recoulor(ImageC[Sprite], BGR-20, BGB-20, BGG-20, &tex, false);
		SDL_SetTextureAlphaMod(tex, Alpha);
		SDL_RenderCopyEx( Rend, tex, &Re, &Wri, cRot, NULL, Flipped);
		if((tex)!=NULL)
		SDL_DestroyTexture(tex); 
		}
		else
		{
		SDL_RenderCopyEx( Rend, Images[Sprite], &Re, &Wri, cRot, NULL, Flipped);	
		}
		}
		else
		{
		SDL_SetRenderDrawColor(Rend, BGR-DarkerThanBG, BGB-DarkerThanBG, BGG-DarkerThanBG, Alpha);
		SDL_RenderFillRect(Rend, &Wri);	
		}
		}
		}
};

class BGObjectStack
{
	public:
	 BGObject Stack[20000];
	 int active=0;
	 
	 int Draw(SDL_Renderer* rend)
	 {
		if(RunMode!=11)
		{
		for(int i2=1; i2<5; i2++)
		 for(int i=0; i<active+1; i++)
		 {
			 if(Stack[i].Layer==i2)
			 Stack[i].Draw(rend);
			 
		 }
		}
		else
		 {
			for(int i2=1; i2<7; i2++)
		 for(int i=active; i>0; i--)
		 {
			 if(Stack[i].Layer==i2)
			 Stack[i].Draw(rend);
			 
		 } 
			 
		 }
	 }
	 
	 int Delete(int i)
	 {
		Stack[i]=Stack[active];
		Stack[active]=Stack[active+1];
		active--; 
		
	 }
	 
	 int Create(BGObject O)
	 {
		  if(active<20000-1)
		   {
			 active++;
			 Stack[active]=O;
		 }
		 
		 return active;
		 
	 }
	 
	
		 
	 
	 
	 int Clear()
	 {
		 BGObject Empty;
		for(int i=0; i<active+1; i++)
		 {
			  Stack[i]=Empty;
			 
		 } 
		 active=0;
		 
	 }
	 
	 int Manage()
	 {
		 for(int i=0; i<active+1; i++)
		 {
			if(Stack[i].Alpharise>0)Stack[i].Alpha=Stack[i].Alpha-Stack[i].Alpharise;
			if(Stack[i].ZoomPT!=0)Stack[i].Zoomed=Stack[i].Zoomed+Stack[i].ZoomPT;
			if(Stack[i].Alpha<0)Stack[i].Alpha=0;
			if(Stack[i].Lifetime>0)
			{
			Stack[i].Lifetime--;
			if(Stack[i].Lifetime==0)Delete(i);	
			}
			Stack[i].Framing();
			Stack[i].RoZo();
			Stack[i].Move(); 
			 
			
		 }
		 for(int i=0; i<active+1; i++)
		  if(Stack[i].Y>CamY+1200 && Stack[i].CamMove==true)Delete(i); 
	
	 }
	
};

BGObjectStack Background;

std::string abc="ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890 -+";
std::string eName="";

class ScoreTable
{
	public: 
	 std::string name[13];
	 int Score[13];
	 
	 int rPlace(int inScore)
	 {
		 int r=0;
		 for(int i=10; i>0; i--)
		 {
			 if(inScore>Score[i])
			 {
				 r=i;
			 }
			 
		 }
		 return r;
		 
	 }
	 	 int Write()
	 {
  std::ofstream myfile;
  myfile.open ("Scores.txt");
  for(int i=1; i<11; i++)
  {
  myfile << "Name\n";
  myfile << name[i] <<"\n";
    myfile << "Score\n";
  myfile << Score[i] <<"\n";
	}

 
  myfile.close();
  return 0;
	 }
	 
	 int EnterScore(int inScore, int Place, std::string inName)
	 {
		 for(int i=10; i>Place; i--)
		 {
			
			name[i]=name[i-1];
			Score[i]=Score[i-1]; 
		 } 
		 
		 name[Place]=inName;
		 Score[Place]=inScore;
		
		Write();
		 return 0; 
	 }
	 
	 int Draw(SDL_Renderer* rend)
	 {
		 for(int i=1; i<11; i++)
		 {
		
		 SDL_Surface* Result=NULL;
		 SDL_Texture* Drawer=NULL;
		 SDL_Rect Wri;
			Result=TTF_RenderText_Blended_Wrapped(gFont[1], name[i].c_str(), FontC, 600);
			Drawer=SDL_CreateTextureFromSurface(rend, Result);
			SDL_QueryTexture(Drawer, NULL, NULL, &Wri.w, &Wri.h);
			Wri.x=300;
			Wri.y=50+((i-1)*100);
			SDL_RenderCopyEx( rend, Drawer, NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
					SDL_DestroyTexture(Drawer);
		SDL_FreeSurface( Result );
			Result=TTF_RenderText_Blended_Wrapped(gFont[1], std::to_string(Score[i]).c_str(), FontC, 600);
			Drawer=SDL_CreateTextureFromSurface(rend, Result);
			SDL_QueryTexture(Drawer, NULL, NULL, &Wri.w, &Wri.h);
			Wri.x=900;
			Wri.y=50+((i-1)*100);
			SDL_RenderCopyEx( rend, Drawer, NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		SDL_DestroyTexture(Drawer);
		SDL_FreeSurface( Result );
		
		}
	 }
	 

	 
	 	 
	 
	 
	 int Read()
	 {
		 
			std::ifstream file;
	
			std::string str;
	
			file.open("Scores.txt");
			int HilfsInteger=0; 
			int HilfsInteger2=0; 
			while (std::getline(file, str))
			{
			char * writable = new char[str.size() + 1];
			std::copy(str.begin(), str.end(), writable);
			writable[str.size()] = '\0';
			if(speicher=="Name"){ HilfsInteger++; name[HilfsInteger]=str.c_str();}
			if(speicher=="Score"){Score[HilfsInteger]=atoi(str.c_str());}
	
				delete[] writable;
				speicher=str;
			}
		file.close();	
		}
	 
	
};

ScoreTable Scores;

class Object
{
	public:
	 float Alpha=255;
	 float Alpharise=0;
	 float X=0;
	 float Y=0;
	 int h=0;
	 int w=0;
	 float cRot=0;
	 float Rot=0;
	 int Sprite=0;
	 int Frames=0;
	 int cFrame=0;
	 int FrameWait=0;
	 int FrameCounter=0;
	 int HitBoxX=0;
	 int HitBoxY=0;
	 int HitBoxW=0;
	 int HitBoxH=0;
	  SDL_RendererFlip Flipped=SDL_FLIP_NONE;
	  
	 int Children=0;
	 int ChildID[10];
	 bool ChildAngleIsRot[10];
	 int ChildTick[10];
	 int ChildTime[10];
	 
	 float ZoomPT=0;
	 float Zoomed=0;
	 
	 int Lifetime=0;
	 
	 int floorn=0;
	 float Speed=0;
	 float Angle;
	 
	 bool DrawAnti=false;
	 
	 		 int Framing()  //Animation
		 {
			if(Frames>0)
		  {
			 
			if(FrameCounter>=FrameWait)
			{
				
				cFrame++;
				FrameCounter=0;
				if(cFrame>Frames)cFrame=0;
			}
			else
			{
				FrameCounter++;
			}
		}
		}
		
		int Move()
		{
		if(Speed!=0)
		{
		float cAngle=((Angle*M_PI)/180);
			X=X+(cos(cAngle)*Speed);
			Y=Y+(sin(cAngle)*Speed);
		}
		}
		
	int RoZo()
		{
		if(Rot!=0)
		{
			cRot=cRot+Rot;
		}
		}
		
		int Draw(SDL_Renderer* Rend)
		{
		if(Sprite!=0)
		{
	    SDL_Rect Re, Wri;
		Re.x=(cFrame*w)+1; //Fix for the Artefacts. Remove +1 maybe?
		Re.y=0;
		Re.h=h;
		Re.w=w-2; //Fix for the Artefacts. Remove -2 maybe?
		if(Zoomed==0)
		{
		Wri.x=X-CamX;
		Wri.y=Y-CamY;
		Wri.h=h;
		Wri.w=w;
		}
		else
		{
		Wri.x=X-CamX-(((w*Zoomed)-w)/2);
		Wri.y=Y-CamY-(((h*Zoomed)-h)/2);
		Wri.h=h*Zoomed;
		Wri.w=w*Zoomed;
		}
		SDL_SetTextureAlphaMod(Images[Sprite], Alpha);
		if(DrawAnti==false)
		SDL_RenderCopyEx( Rend, Images[Sprite], &Re, &Wri, cRot, NULL, Flipped);
		else
		{
		SDL_SetRenderDrawColor(Rend, ABGR, ABGB, ABGG, Alpha);
		SDL_RenderFillRect(Rend, &Wri);
		}
		}
		}
		
};

class Player
{
	public:
	bool LeftM=false;
	bool RightM=false;
	bool PKey[15];
	bool KeyLock[15];
	Object POb;
	float JumpPower=0;
	float FallSpeed=0;
	int JumpPress=0;
	int DireLock=0;
	float SpeedMod=4.2;
	float SpeedModSlow=0.3;
	float SpeedModAir=4.2;
	float SpeedModAirSlow=0.2;
	int CoyoteTime=0;
	float Combo=0;
	float ComboTimer=0;
	float ComboCharge=0;
	bool SJumpBlock=false;
	int CloneCreate=0;
	int KeyboardKeys[15];
	
};
Player P1;
Object Objectlist[100];
int P1Charge=0;





class ObjectStack
{
	public:
	 Object Stack[StackSize];
	 int active=0;
	 
	 int Draw(SDL_Renderer* rend)
	 {
		 for(int i=0; i<active+1; i++)
		 {
			 Stack[i].Draw(rend);
			 
		 }
	 }
	 
	 int Delete(int i)
	 {
		Stack[i]=Stack[active];
		Stack[active]=Stack[active+1];
		active--; 
		
	 }
	 
	 int Create(Object O)
	 {
		  if(active<StackSize-1)
		   {
			 active++;
			 Stack[active]=O;
		 }
		 
		 return active;
		 
	 }
	 
	 int ClearFloorn(int c)
	 {
		for(int i=0; i<active+1; i++)
		 {
			 if(Stack[i].floorn==c)
			  Stack[i].floorn=0;
			 
		 } 
		 
	 }
	 
	 int Clear()
	 {
		 Object Empty;
		for(int i=0; i<active+1; i++)
		 {
			  Stack[i]=Empty;
			 
		 } 
		 active=0;
		 
	 }
	 
	 int Manage()
	 {
		 for(int i=0; i<active+1; i++)
		 {
			if(Stack[i].Alpharise>0)Stack[i].Alpha=Stack[i].Alpha-Stack[i].Alpharise;
			if(Stack[i].ZoomPT!=0)Stack[i].Zoomed=Stack[i].Zoomed+Stack[i].ZoomPT;
			if(Stack[i].Alpha<0)Stack[i].Alpha=0;
			if(Stack[i].Lifetime>0)
			{
			Stack[i].Lifetime--;
			if(Stack[i].Lifetime==0)Delete(i);	
			}
			if(Stack[i].Children>0)
			{
				for(int i2=1; i2<Stack[i].Children+1; i2++)
				{
					if(Stack[i].ChildTick[i2]<Stack[i].ChildTime[i2])
					{
						Stack[i].ChildTick[i2]++;
					}
					else
					{
						Stack[i].ChildTick[i2]=0;
						int r=Create(Objectlist[Stack[i].ChildID[i2]]);
						Stack[r].X=Stack[i].X+Stack[r].X;
						Stack[r].Y=Stack[i].Y+Stack[r].Y;
						if(Stack[i].ChildAngleIsRot[i2]==true)
						{
							Stack[r].Angle=Stack[i].cRot;
						}
					}
					
				}
				
			}
			Stack[i].Framing();
			Stack[i].RoZo();
			Stack[i].Move(); 
			 
			
		 }
		 for(int i=0; i<active+1; i++)
		  if(Stack[i].Y>CamY+1200)Delete(i); 
	 }
	
};

ObjectStack Walls;
ObjectStack Floors;
ObjectStack Enemys;
ObjectStack Clones;


int CreateClone(int Dur=0, float ar=0, float ZPT=0)
 {
			if(NoFun==false)
			{
	 				Object C;
				C=P1.POb;
				C.Alpharise=ar;
				C.ZoomPT=ZPT;
				if(C.Sprite==2)C.Sprite=500+(rand()%99);
				if(C.Sprite==10)C.Sprite=600+(rand()%99);
				if(C.Sprite==11)C.Sprite=700+(rand()%99);
				C.FrameWait=99999999;
				C.Speed=0;
				C.Lifetime=Dur;
				Clones.Create(C); 
			}
				}

int LoadMusic()
{
	int newCounter=0;
	
	std::ifstream file;
	std::string str;
	file.open("Music.txt");
	while (std::getline(file, str))
		{
		//std::cout << "Line Loaded" << std::endl;
			char* writable = new char[str.size() + 1];
			std::copy(str.begin(), str.end(), writable);
			writable[str.size()] = '\0';
			newCounter++;
			Music[newCounter]=Mix_LoadMUS(writable);
		delete[] writable;
			
		
		}
		file.close();
		
	return newCounter;
}

int Restart()
{
	 CamX=0;
 CamY=0;
 TowerHeight=0;
 floorC=0;
 Scroller=0;
 maxL=6;
 minL=6;
 maxD=2;
 lastS=4;
 Walled=true;
 Score=0;
 BGR=200;
BGG=200;
BGB=200;
GameOver=false;
 Mix_HaltMusic();
 cVolume=0;
 
	
	P1.POb.Sprite=2;
	P1.POb.w=50;
	P1.POb.h=100;
	P1.POb.Frames=5;
	P1.POb.FrameWait=5;
	P1.POb.Speed=0;
	P1.FallSpeed=0;
	P1.Combo=0;
	P1.ComboTimer=0;
	P1.CoyoteTime=0;
	P1.POb.X=(1920/2)-50;
	P1.POb.Y=(1080/2)-150;
	
	
	Walls.Clear();
	Floors.Clear();
	Clones.Clear();
	Background.Clear();
	BGObject star;
	for(int i=0; i<(100+(rand()%500)); i++)
	{
		int si=rand()%5;
		star.w=4+si;
		star.h=4+si;
		star.Sprite=1;
		star.X=0+rand()%1920;
		star.Y=0+rand()%1080;
		star.Layer=1;
		star.DarkerThanBG=5+rand()%60;
		Background.Create(star);
	}
	
	 BGObject m;
	 m.Sprite=14;
	 m.w=150;
	 m.h=150;
	 m.X=100+(rand()%150);
	 m.Y=100+(rand()%150);
	 m.Layer=1;
	 Background.Create(m);
	 float Speed=-2+(rand()%4);
	 Speed=Speed+((rand()%100)/100);
	 for(int i=0; i<1+(rand()%40); i++)
	 {
		m.Sprite=16; 
		m.w=220;
		m.h=150;
		m.X=-900+(rand()%2100);
		m.Y=-100+(rand()%2000);
		m.maxX=2500;
		m.minX=-1500;
		m.Angle=0;
		m.Speed=Speed;
		m.Layer=2;
		if(rand()%3>1)m.Flipped=SDL_FLIP_HORIZONTAL;
		else m.Flipped=SDL_FLIP_NONE;
		m.NoReco=true;
		Background.Create(m);
		 
	 }
	 
	Object Ob;
	for(int i=0; i<15; i++)
	{
	Ob.Sprite=5;
	Ob.w=100;
	Ob.h=100;
	Ob.X=510;
	Ob.Y=500-(i*100);
	Ob.DrawAnti=true;
	Walls.Create(Ob);
	
		Ob.Sprite=5;
	Ob.w=100;
	Ob.h=100;
	Ob.X=2110;
	Ob.Y=500-(i*100);
	Walls.Create(Ob);
	
	BGObject c;
				c.DarkerThanBG=50-(rand()%10);
				c.w=1500;
				c.h=100;
				c.X=610;
				c.Y=500-(i*100);
				c.CamMove=true;
				c.Layer=3;
				Background.Create(c);
	
	}
	BGObject c;
	c.X=0;
	c.Y=600;
	c.w=2500;
	c.h=900;
	c.Layer=3;
	c.CamMove=true;
	c.DarkerThanBG=100;
	Background.Create(c);
	for(int i2=0; i2<5; i2++)
	{
	int start=rand()%5;
	for(int i=0; i<15; i++)
	{
		Ob.h=10;
		Ob.X=610+(i*100);
		Ob.Y=600-(i2*300);
		Ob.DrawAnti=true;
		TowerHeight=600-(i2*300);
		if(i2==0 || (i>start && i<start+10))
		Floors.Create(Ob);
					
	}
	}
	
}


int loadSettings(char* mainfile)
{
			std::ifstream file;
	
			std::string str;
	
			file.open(mainfile);
			int HilfsInteger=0; 
			int HilfsInteger2=0; 
			while (std::getline(file, str))
			{
			char * writable = new char[str.size() + 1];
			std::copy(str.begin(), str.end(), writable);
			writable[str.size()] = '\0';
			if(speicher=="Fullscreen"){FullScreen=atoi(str.c_str());}
			if(speicher=="GreyMode"){NoFun=atoi(str.c_str());}
			if(speicher=="MusicVol"){MusicVol=atoi(str.c_str());}
			if(speicher=="SoundVol"){SoundVol=atoi(str.c_str());}
			if(speicher=="Gamepad"){CMode=atoi(str.c_str());}
			if(speicher=="Key1"){P1.KeyboardKeys[1]=atoi(str.c_str());}
			if(speicher=="Key2"){P1.KeyboardKeys[2]=atoi(str.c_str());}
			if(speicher=="Key3"){P1.KeyboardKeys[3]=atoi(str.c_str());}
			if(speicher=="Key4"){P1.KeyboardKeys[4]=atoi(str.c_str());}
			if(speicher=="Key5"){P1.KeyboardKeys[5]=atoi(str.c_str());}
			if(speicher=="Mono"){Mono=atoi(str.c_str());}
			if(speicher=="PadDeadZone"){DZone=atoi(str.c_str());}
			if(speicher=="ControllerB1")
			{	
				ControllerButton1=SDL_GameControllerGetButtonFromString(writable);
			}			
				delete[] writable;
				speicher=str;
			}
		file.close();	
}

int WriteSettings()
{
  std::ofstream myfile;
  myfile.open ("Settings.txt");
  myfile << "Fullscreen\n";
  myfile << FullScreen <<"\n";
  myfile << "GreyMode\n";
  myfile << NoFun <<"\n";
  myfile << "MusicVol\n";
  myfile << MusicVol <<"\n";
  myfile << "SoundVol\n";
  myfile << SoundVol <<"\n";
  myfile << "Gamepad\n";
  myfile << CMode <<"\n";
  myfile << "Key1\n";
  myfile << P1.KeyboardKeys[1] <<"\n"; 
  myfile << "Key2\n";
  myfile << P1.KeyboardKeys[2] <<"\n"; 
  myfile << "Key3\n";
  myfile << P1.KeyboardKeys[3] <<"\n"; 
  myfile << "Key4\n";
  myfile << P1.KeyboardKeys[4] <<"\n"; 
  myfile << "Key5\n";
  myfile << P1.KeyboardKeys[5] <<"\n"; 
    myfile << "ControllerB1\n";
  myfile << SDL_GameControllerGetStringForButton(ControllerButton1) <<"\n"; 
  myfile << "PadDeadZone\n";
  myfile << DZone <<"\n"; 
  myfile << "Mono\n";
  myfile << Mono <<"\n"; 
  myfile.close();
  return 0;
}

int DoJoystick()
{
	if( SDL_NumJoysticks() < 1 ) 
		{ 
			  SDL_ShowCursor(SDL_DISABLE);
			CMode=0;
			printf( "No Gamepad\n" ); 
			
		} 
		else 
		{
			for(int i=0; i<SDL_NumJoysticks(); i++)
			{
			
			//try controllermode
			if(i==0)
			{
			 controller = SDL_GameControllerOpen(i);
				if (controller) {
					std::cout << "Initialised Gamepad as GameController, Name " << SDL_GameControllerName(controller) << std::endl;
					if(SDL_GameControllerMapping(controller)==NULL)
					{
						CMode=0;
						std::cout << "No Mapping avaible. Using Keyboard Mode" << std::endl;
						
					}
				}
			}

		}
		}
	}

int iniSDL()
{
if( SDL_Init( SDL_INIT_VIDEO ) < 0 ) { printf( "SDL konnte nicht initialisiert werden: %s\n", SDL_GetError() ); }
		else { 
		 if( !SDL_SetHint( SDL_HINT_RENDER_SCALE_QUALITY, "1" ) ) { printf( "Warning: Linear texture filtering not enabled!" ); }
		if(AntiA==true)
		{
		SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
		SDL_GL_SetAttribute(SDL_GL_MULTISAMPLEBUFFERS, 1);
	    SDL_GL_SetAttribute(SDL_GL_MULTISAMPLESAMPLES, 2);
		SDL_GL_SetAttribute(SDL_GL_ACCELERATED_VISUAL, 1);
		}
		  for(int i = 0; i < SDL_GetNumVideoDisplays(); ++i)
		{
		
		int should_be_zero = SDL_GetCurrentDisplayMode(i, &DMode);

		 if(should_be_zero != 0)
  	
 	    SDL_Log("SDL-Fehler bei der Ausgabe #%d: %s", i, SDL_GetError());

		 else
 	   

		
	   SDL_Log("Anzeige #%d: Modus: %dx%dpx @ %dhz. \n", i, DMode.w, DMode.h, DMode.refresh_rate);
		  }
 
		}
				if(FullScreen==1)
			  Window=SDL_CreateWindow("Acid Flight", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, DMode.w, DMode.h, SDL_WINDOW_SHOWN | SDL_WINDOW_FULLSCREEN | SDL_WINDOW_OPENGL ); 
		else if(FullScreen==2)
			  Window=SDL_CreateWindow("Acid Flight", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, DMode.w, DMode.h, SDL_WINDOW_SHOWN | SDL_WINDOW_BORDERLESS | SDL_WINDOW_OPENGL ); 
		else if(FullScreen==0)
			Window=SDL_CreateWindow("Acid Flight", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, DMode.w, DMode.h, SDL_WINDOW_SHOWN | SDL_WINDOW_OPENGL | SDL_WINDOW_RESIZABLE ); 
		

//ini Sound!
if(Mono==false)
 {if( Mix_OpenAudio( 44100, MIX_DEFAULT_FORMAT, 2, 2048 ) < 0 ) { printf( "Ton-Wiedergabe nicht möglich :(: %s\n", Mix_GetError() );}}
 else
 if( Mix_OpenAudio( 44100, MIX_DEFAULT_FORMAT, 1, 2048 ) < 0 ) { printf( "Ton-Wiedergabe nicht möglich :(: %s\n", Mix_GetError() );}
	Mix_AllocateChannels(48);
	//ini gamepad
	   SDL_InitSubSystem(SDL_INIT_JOYSTICK);
	   SDL_InitSubSystem(SDL_INIT_GAMECONTROLLER);
	   SDL_SetHint(SDL_HINT_JOYSTICK_ALLOW_BACKGROUND_EVENTS,"1");
	   DoJoystick();
	 
     SDL_ShowCursor(SDL_DISABLE);
}

SDL_Texture* loadTexture( std::string path ) { 
	SDL_Texture* newTexture = NULL; 
		SDL_Surface* loadedSurface = IMG_Load( path.c_str() ); 
	if( loadedSurface == NULL ) { printf( "Unable to load image %s! SDL_image Error: %s\n", path.c_str(), IMG_GetError() ); } else { 
		newTexture = SDL_CreateTextureFromSurface( Renderer, loadedSurface ); if( newTexture == NULL ) { printf( "Unable to create texture from %s! SDL Error: %s\n", path.c_str(), SDL_GetError() ); } 
		
		SDL_FreeSurface( loadedSurface ); } return newTexture; }
		
int loadImages(char* bildliste)
{
			texturesUsed=1;
			std::ifstream file;
			file.open(bildliste);
			std::string str; 
			while (std::getline(file, str))
			{
			   
			   
  			   Images[texturesUsed] = loadTexture( str );
  			   SDL_Delay(5);
  			   ImageC[texturesUsed] = IMG_Load( str.c_str() ); 
  			   if(texturesUsed==2)
  			   {
				   
				   SDL_Surface* loadedSurface = IMG_Load( str.c_str() );
				    for(int i=1; i<99; i++)
				    Recoulor(loadedSurface, 50+(rand()%90), 6+(rand()%40), 50+(rand()%90), &Images[500+i]);
				   SDL_FreeSurface( loadedSurface );
			   }
			    if(texturesUsed==10)
  			   {
				   
				   SDL_Surface* loadedSurface = IMG_Load( str.c_str() );
				    for(int i=1; i<99; i++)
				    Recoulor(loadedSurface, 50+(rand()%90), 6+(rand()%40), 50+(rand()%90), &Images[600+i]);
				   SDL_FreeSurface( loadedSurface );
			   }
			   	if(texturesUsed==11)
  			   {
				   
				   SDL_Surface* loadedSurface = IMG_Load( str.c_str() );
				    for(int i=1; i<99; i++)
				    Recoulor(loadedSurface, 50+(rand()%90), 6+(rand()%40), 50+(rand()%90), &Images[700+i]);
				   SDL_FreeSurface( loadedSurface );
			   }

			   texturesUsed++;
			 }
			file.close();
		
};
		
int Events()
{		 int Mx1;
		 int My1;
		 int out=0;
			 int returner=0;
		 float xrel=0;
		 float yrel=0;
		 SDL_DisplayMode DM;
		 int gx, gy;
		 float offsetterY;
		 float offsetterX;
		 
		 //Adjact X/Y-Values to logical Rendersize

		
		SDL_GetWindowSize(Window, &DM.w,  &DM.h);
		SDL_RenderGetLogicalSize(Renderer, &gx, &gy);
			
		
		float DMH=DM.h;
		float DMW=DM.w;
		float GX=gx;
		float GY=gy;
		int Mx=0;
		int My=0;
		if(FullScreen==1)
		{
		offsetterY=(float)((DMH-((DMW/GX)*GY))/2);
		offsetterX=(float)((DMW-((DMH/GY)*GX))/2);
		
		if(offsetterX<offsetterY)offsetterX=0;
		else offsetterY=0;
		
		//std::cout << "OffsetterX: " << offsetterX << " Offsetter Y: " << offsetterY << std::endl;
		xrel=(float)GX/(DMW-(offsetterX*2));
		yrel=(float)GY/(DMH-(offsetterY*2));
		
		
		 SDL_GetMouseState(&Mx1, &My1); //Get Mouse State,
		 
		  //Adjact to Logical Rendersize
		  Mx=(Mx1-offsetterX)*xrel;
		  My=(My1-offsetterY)*yrel;	
		 }
		  
		  if(FullScreen==0) //no fullscreen?
		  {
			
			 float ratio=(float)DM.w/DM.h;
			 float nRatio=(float)1920/1080;
			 float Factor=0;
			 int mW=0;
			 int mH=0;
			  //std::cout << "Windowed. Ratio: " << ratio << " ";
			 if(ratio<nRatio)
			 {
				// std::cout << "Thinner than original."; 
				 //getting hight
				 float weidth=DM.w;
				 float adaptor=weidth/GX;
				 Factor=adaptor;
				 float height=GY*adaptor;
				 //std::cout << height << " ";
				 mH=(DM.h-height)/2;
				 //std::cout << " need to remove " << mH << " ";
			 }
			 if(ratio>nRatio) 
			 {
				 //std::cout << "Fatter than original";
				 float height=DM.h;
				 float adaptor=height/GY;
				 Factor=adaptor;
				 float weidth=GX*adaptor;
				 //std::cout << weidth << " ";
				 mW=(DM.w-weidth)/2;
				 //std::cout << " need to remove " << mW << " ";
			 }
			 SDL_GetMouseState(&Mx1, &My1);
			 Mx=((Mx1)-mW)/Factor;
			 My=((My1)-mH)/Factor;
			 
			 //std::cout << std::endl;
		  }
		 // std::cout << Mx << " || " << My << std::endl;
		  P1.LeftM=(SDL_GetMouseState(NULL, NULL) & SDL_BUTTON(SDL_BUTTON_LEFT));
		  P1.RightM=(SDL_GetMouseState(NULL, NULL) & SDL_BUTTON(SDL_BUTTON_RIGHT));
		 
		while( SDL_PollEvent( &event ) ){
		switch( event.type ){
				case SDL_CONTROLLERDEVICEADDED:
			  {
				 DoJoystick();
				  
			  }
			break;
			case SDL_CONTROLLERBUTTONUP:
			 {
				 if(InputDef==true && Keylock==false)
				 {
					if(InN==1)ControllerButton1=SDL_GameControllerButton(event.cbutton.button); 
					
					InN++;
					if(InN>1){
						Keylock=true;
						InputDef=false;
						InN=1;
						}
				 }
				 if(Keylock==true && InputDef==true)Keylock=false;
			 }
			 break;
		  case SDL_KEYDOWN:
		  {
			if(event.key.keysym.sym==SDLK_ESCAPE)
				{
				 if(RunMode==0 || (RunMode==10 && TimeIn>300 ))
					 running=false;
					 else
					 {
					 if(RunMode!=10)
					 {
					 RunMode=0;
					 Mix_HaltMusic();
					 }
					 }
				 }
				 if(event.key.keysym.sym==SDLK_F10)
				{
				
					 NoFun=true;
				 }
			 }
			 break;
			case SDL_KEYUP:
			{
			if(InputDef==true)
			 {
				if(Keylock==false)
				{
			    P1.KeyboardKeys[InN]=event.key.keysym.sym;
			   	InN++;
			   	if(InN>5){
					InputDef=false;
					Keylock=true;
					InN=1;
					}
				}
				else
				 Keylock=false;
				
			 }	
				
			}
			break;
		 }
		}
		
		
		if(CMode==0)
		{
		const Uint8 *state = SDL_GetKeyboardState(NULL);
		if (state[SDL_GetScancodeFromKey(P1.KeyboardKeys[1])]) 
		P1.PKey[1]=true;
		else
		{
		P1.PKey[1]=false;
		P1.KeyLock[1]=false;
		}
		if (state[SDL_GetScancodeFromKey(P1.KeyboardKeys[2])]) 
		P1.PKey[2]=true;
		else
		{
		P1.PKey[2]=false;
		P1.KeyLock[2]=false;
		}
		if (state[SDL_GetScancodeFromKey(P1.KeyboardKeys[3])]) 
		P1.PKey[3]=true;
		else
		{
		P1.PKey[3]=false;
		P1.KeyLock[3]=false;
		}
		if (state[SDL_GetScancodeFromKey(P1.KeyboardKeys[4])]) 
		P1.PKey[4]=true;
		else
		{
		P1.PKey[4]=false;
		P1.KeyLock[4]=false;
		}
		if (state[SDL_GetScancodeFromKey(P1.KeyboardKeys[5])]) 
		P1.PKey[5]=true;
		else
		{
		P1.PKey[5]=false;
		P1.KeyLock[5]=false;
		}
		
		if(SDL_GetScancodeFromKey(P1.KeyboardKeys[1])!=SDL_SCANCODE_UP)
		{
			if (state[SDL_SCANCODE_UP]) 
				P1.PKey[6]=true;
				else
				{
				P1.PKey[6]=false;
				P1.KeyLock[6]=false;
				}	
		}
		if(SDL_GetScancodeFromKey(P1.KeyboardKeys[2])!=SDL_SCANCODE_DOWN)
		{
			if (state[SDL_SCANCODE_DOWN]) 
				P1.PKey[7]=true;
				else
				{
				P1.PKey[7]=false;
				P1.KeyLock[7]=false;
				}	
		}
		
		if(SDL_GetScancodeFromKey(P1.KeyboardKeys[5])!=SDL_SCANCODE_RETURN)
		{
			if (state[SDL_SCANCODE_RETURN]) 
				P1.PKey[8]=true;
				else
				{
				P1.PKey[8]=false;
				P1.KeyLock[8]=false;
				}	
		}
		
		
		}
		else
		{
		if(SDL_GameControllerGetButton(controller, SDL_CONTROLLER_BUTTON_DPAD_UP)==1 ||SDL_GameControllerGetAxis(controller, SDL_CONTROLLER_AXIS_LEFTY )<(-1*DZone))
					P1.PKey[1]=true;
					else
					{
					P1.PKey[1]=false;
					P1.KeyLock[1]=false;
					}
		if(SDL_GameControllerGetButton(controller, SDL_CONTROLLER_BUTTON_DPAD_DOWN)==1 ||  SDL_GameControllerGetAxis(controller, SDL_CONTROLLER_AXIS_LEFTY )>DZone)
			 P1.PKey[2]=true;
			else
			{
			P1.PKey[2]=false;
			P1.KeyLock[2]=false;
			}
		if(SDL_GameControllerGetButton(controller, SDL_CONTROLLER_BUTTON_DPAD_LEFT)==1 || SDL_GameControllerGetAxis(controller, SDL_CONTROLLER_AXIS_LEFTX )<(-1*DZone))
			P1.PKey[3]=true;
			else
			{
			P1.PKey[3]=false;
			P1.KeyLock[3]=false;
			}
		if(SDL_GameControllerGetButton(controller, SDL_CONTROLLER_BUTTON_DPAD_RIGHT)==1 || SDL_GameControllerGetAxis(controller, SDL_CONTROLLER_AXIS_LEFTX )>DZone)
		 P1.PKey[4]=true;
		else
		{
		P1.PKey[4]=false;
		P1.KeyLock[4]=false;
		}
		if(SDL_GameControllerGetButton(controller, ControllerButton1)==true)
		P1.PKey[5]=true;
		else
		{
		P1.PKey[5]=false;
		P1.KeyLock[5]=false;
		}
			
		}
}


int ShowScore(int sc, int x, int y, int craze=0)
{
	//Show Score
			
				std::string s;
	
				s = std::to_string(sc);
				SDL_Rect targ;
				targ.x=x;
				targ.y=y;
				targ.w=25;
				targ.h=33;
		
				SDL_Rect read;
				read.x=0;
				read.y=0;
				read.w=25;
				read.h=33;
				if(craze==0)
				{
				for(int i=0; i<s.length(); i++)
				{
					
						
					
					std::string a=s.substr (i,1);
					if(a=="0")
					{
					read.x=225;
					read.y=0;
					 SDL_RenderCopyEx( Renderer, Images[12], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					}
					if(a=="1")
					{
					read.x=0;
					read.y=0;

					 SDL_RenderCopyEx( Renderer, Images[12], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					}
					if(a=="2")
					{
					read.x=25;
					read.y=0;

					 SDL_RenderCopyEx( Renderer, Images[12], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					}
					if(a=="3")
					{
					read.x=50;
					read.y=0;

					 SDL_RenderCopyEx( Renderer, Images[12], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					}
					if(a=="4")
					{
					read.x=75;
					read.y=0;

					 SDL_RenderCopyEx( Renderer, Images[12], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					}
					if(a=="5")
					{
					read.x=100;
					read.y=0;

					 SDL_RenderCopyEx( Renderer, Images[12], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					}
					if(a=="6")
					{
					read.x=125;
					read.y=0;

					 SDL_RenderCopyEx( Renderer, Images[12], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					}
					if(a=="7")
					{
					read.x=150;
					read.y=0;

					 SDL_RenderCopyEx( Renderer, Images[12], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					}
					if(a=="8")
					{
					read.x=175;
					read.y=0;

					 SDL_RenderCopyEx( Renderer, Images[12], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					}
					if(a=="9")
					{
					read.x=200;
					read.y=0;

					 SDL_RenderCopyEx( Renderer, Images[12], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					}
					targ.x=targ.x+targ.w;
				}
				}
				else
				{
					targ.w=25+(craze/3);
					targ.h=33+(craze/3);
					
					if(targ.w>50)targ.w=50;
					if(targ.h>58)targ.h=58;
					if(rand()%100>100-craze && NoFun==false)
					{
					Recoulor(ImageC[8], (0+(rand())%craze*10), (0+(rand())%craze*10), (0+(rand())%craze*10), &Images[8]);
					Recoulor(ImageC[9], (255-(rand())%craze*10), (255-(rand())%craze*10), (255-(rand())%craze*10), &Images[9]);
					}
					for(int i=0; i<s.length(); i++)
				{
					
					std::string a=s.substr (i,1);
					if(a=="0")
					{
					read.x=225;
					read.y=0;
					 SDL_RenderCopyEx( Renderer, Images[8], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					 SDL_RenderCopyEx( Renderer, Images[9], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					}
					if(a=="1")
					{
					read.x=0;
					read.y=0;

					 SDL_RenderCopyEx( Renderer, Images[8], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					 SDL_RenderCopyEx( Renderer, Images[9], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					}
					if(a=="2")
					{
					read.x=25;
					read.y=0;

					 SDL_RenderCopyEx( Renderer, Images[8], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					 SDL_RenderCopyEx( Renderer, Images[9], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					}
					if(a=="3")
					{
					read.x=50;
					read.y=0;

					 SDL_RenderCopyEx( Renderer, Images[8], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					 SDL_RenderCopyEx( Renderer, Images[9], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					}
					if(a=="4")
					{
					read.x=75;
					read.y=0;

					 SDL_RenderCopyEx( Renderer, Images[8], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					 SDL_RenderCopyEx( Renderer, Images[9], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					}
					if(a=="5")
					{
					read.x=100;
					read.y=0;

					 SDL_RenderCopyEx( Renderer, Images[8], &read, &targ, NULL, NULL, SDL_FLIP_NONE);
					 SDL_RenderCopyEx( Renderer, Images[9], &read, &targ, NULL, NULL, SDL_FLIP_NONE);		
					}
					if(a=="6")
					{
					read.x=125;
					read.y=0;

					 SDL_RenderCopyEx( Renderer, Images[8], &read, &targ, NULL, NULL, SDL_FLIP_NONE);
					 SDL_RenderCopyEx( Renderer, Images[9], &read, &targ, NULL, NULL, SDL_FLIP_NONE);		
					}
					if(a=="7")
					{
					read.x=150;
					read.y=0;

					 SDL_RenderCopyEx( Renderer, Images[8], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					 SDL_RenderCopyEx( Renderer, Images[9], &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
					}
					if(a=="8")
					{
					read.x=175;
					read.y=0;

					 SDL_RenderCopyEx( Renderer, Images[8], &read, &targ, NULL, NULL, SDL_FLIP_NONE);
					 SDL_RenderCopyEx( Renderer, Images[9], &read, &targ, NULL, NULL, SDL_FLIP_NONE);		
					}
					if(a=="9")
					{
					read.x=200;
					read.y=0;

					 SDL_RenderCopyEx( Renderer, Images[8], &read, &targ, NULL, NULL, SDL_FLIP_NONE);
					 SDL_RenderCopyEx( Renderer, Images[9], &read, &targ, NULL, NULL, SDL_FLIP_NONE);		
					}
					targ.x=targ.x+targ.w;
				}
					
				}
	
}

int GraphicHandler()
{
		SDL_SetRenderDrawColor(Renderer, 0, 0, 0, 255);
		SDL_RenderClear( Renderer );
		
		
			//Weißer BG, später öndern :3
			SDL_SetRenderDrawColor(Renderer, BGR, BGG, BGB, 255);
			SDL_Rect FillerFee;
			FillerFee.x=0;
			FillerFee.y=0;
			FillerFee.w=1920;
			FillerFee.h=1080;
			
			SDL_RenderFillRect(Renderer, &FillerFee);
			Background.Draw(Renderer);
			Clones.Draw(Renderer);
			P1.POb.Draw(Renderer);
			
			Walls.Draw(Renderer);
			Floors.Draw(Renderer);
			Enemys.Draw(Renderer);
			
				 ShowScore(Score, 20, 10);
				 
				 ShowScore(P1.Combo, 20, 60, P1.Combo);
				 // Old: Show Functions
				 // ShowScore(P1.ComboTimer, 20, 110);
				// ShowScore(P1.ComboCharge, 20, 160);	
				//New: Show Bar
				if(NoFun==false)
				{
				SDL_SetRenderDrawBlendMode(Renderer, SDL_BLENDMODE_BLEND);
				FillerFee.x=20;
				FillerFee.y=120;
				FillerFee.w=50;
				FillerFee.h=200;
				if(P1.ComboTimer>0 && P1.ComboCharge>=10)
				SDL_SetRenderDrawColor(Renderer, 160+(rand()%80), 0, 160+(rand()%80), 255);
				else
				SDL_SetRenderDrawColor(Renderer, 120, 120, 120, 255);
				SDL_RenderFillRect(Renderer, &FillerFee);
				FillerFee.x=25;
				FillerFee.y=125;
				FillerFee.w=40;
				FillerFee.h=190;
				SDL_SetRenderDrawColor(Renderer, 50, 50, 50, 255);
				SDL_RenderFillRect(Renderer, &FillerFee);
				if(P1.ComboTimer>0)
				{
				FillerFee.x=25;
				FillerFee.y=125;
				FillerFee.w=40;
				FillerFee.h=(float)190*(P1.ComboTimer/25);
				if(FillerFee.h>190)FillerFee.h=190;
				SDL_SetRenderDrawColor(Renderer, 180, 0, 120, 255);
				SDL_RenderFillRect(Renderer, &FillerFee);
				}
				if(P1.ComboCharge>0)
				{
				FillerFee.x=25;
				FillerFee.y=125;
				FillerFee.w=40;
				FillerFee.h=(float)190*(P1.ComboCharge/10);
				if(FillerFee.h>190)FillerFee.h=190;
				SDL_SetRenderDrawColor(Renderer, 80, 0, 150, 140);
				SDL_RenderFillRect(Renderer, &FillerFee);
				}
				SDL_SetRenderDrawBlendMode(Renderer, SDL_BLENDMODE_NONE);
				}
				else
				{
				SDL_SetRenderDrawBlendMode(Renderer, SDL_BLENDMODE_BLEND);
				FillerFee.x=20;
				FillerFee.y=120;
				FillerFee.w=50;
				FillerFee.h=200;
				if(P1.ComboTimer>0 && P1.ComboCharge>=10)
				SDL_SetRenderDrawColor(Renderer, 80+(rand()%40), 80+(rand()%40), 80+(rand()%40), 255);
				else
				SDL_SetRenderDrawColor(Renderer, 0, 0, 0, 255);
				SDL_RenderFillRect(Renderer, &FillerFee);
				FillerFee.x=25;
				FillerFee.y=125;
				FillerFee.w=40;
				FillerFee.h=190;
				SDL_SetRenderDrawColor(Renderer, 0, 0, 0, 255);
				SDL_RenderFillRect(Renderer, &FillerFee);
				if(P1.ComboTimer>0)
				{
				FillerFee.x=25;
				FillerFee.y=125;
				FillerFee.w=40;
				FillerFee.h=(float)190*(P1.ComboTimer/25);
				if(FillerFee.h>190)FillerFee.h=190;
				SDL_SetRenderDrawColor(Renderer, 125, 125, 125, 255);
				SDL_RenderFillRect(Renderer, &FillerFee);
				}
				if(P1.ComboCharge>0)
				{
				FillerFee.x=25;
				FillerFee.y=125;
				FillerFee.w=40;
				FillerFee.h=(float)190*(P1.ComboCharge/10);
				if(FillerFee.h>190)FillerFee.h=190;
				SDL_SetRenderDrawColor(Renderer, 150, 150, 150, 140);
				SDL_RenderFillRect(Renderer, &FillerFee);
				}
				SDL_SetRenderDrawBlendMode(Renderer, SDL_BLENDMODE_NONE);	
					
				}
				//Bar end
				 SDL_Surface* Result=NULL;
				 SDL_Texture* Drawer=NULL;
			if(GameOver==true)	
			{
				
			
				 SDL_Rect Wri;
				 std::string Output;
				 if(ScorePlace==0)
				 {
				 Output="Game Over.";
				 Result=TTF_RenderText_Blended_Wrapped(gFont[1], Output.c_str(), FontC, 600);
				Drawer=SDL_CreateTextureFromSurface(Renderer, Result);
				SDL_FreeSurface(Result);
					SDL_QueryTexture(Drawer, NULL, NULL, &Wri.w, &Wri.h);
					Wri.x=(1920/2)-(Wri.w/2);
					Wri.y=400;
					SDL_RenderCopyEx( Renderer, Drawer, NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
					SDL_DestroyTexture(Drawer);
					Output= "Score: ";
					Output.append(std::to_string(Score));  
					Result=TTF_RenderText_Blended_Wrapped(gFont[1], Output.c_str(), FontC, 1000);
					Drawer=SDL_CreateTextureFromSurface(Renderer, Result);
					SDL_FreeSurface(Result);
					SDL_QueryTexture(Drawer, NULL, NULL, &Wri.w, &Wri.h);
					Wri.x=(1920/2)-(Wri.w/2);
					Wri.y=500;
					SDL_RenderCopyEx( Renderer, Drawer, NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
					SDL_DestroyTexture(Drawer);
				    if(mSelect==1)Output= "> Retry";
				    else Output= "Retry";
					Result=TTF_RenderText_Blended_Wrapped(gFont[1], Output.c_str(), FontC, 1000);
					Drawer=SDL_CreateTextureFromSurface(Renderer, Result);
					SDL_FreeSurface(Result);
					SDL_QueryTexture(Drawer, NULL, NULL, &Wri.w, &Wri.h);
					Wri.x=(1920/2)-(Wri.w/2);
					Wri.y=700;
					SDL_RenderCopyEx( Renderer, Drawer, NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
					SDL_DestroyTexture(Drawer);
					if(mSelect==2)Output= "> Exit";
				    else Output= "Exit";
					Result=TTF_RenderText_Blended_Wrapped(gFont[1], Output.c_str(), FontC, 1000);
					Drawer=SDL_CreateTextureFromSurface(Renderer, Result);
					SDL_FreeSurface(Result);
					SDL_QueryTexture(Drawer, NULL, NULL, &Wri.w, &Wri.h);
					Wri.x=(1920/2)-(Wri.w/2);
					Wri.y=800;
					SDL_RenderCopyEx( Renderer, Drawer, NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
					SDL_DestroyTexture(Drawer);
				}
				else
				{
					 Output="New Highscore";
				 Result=TTF_RenderText_Blended_Wrapped(gFont[1], Output.c_str(), FontC, 600);
				Drawer=SDL_CreateTextureFromSurface(Renderer, Result);
				SDL_FreeSurface(Result);
					SDL_QueryTexture(Drawer, NULL, NULL, &Wri.w, &Wri.h);
					Wri.x=(1920/2)-(Wri.w/2);
					Wri.y=400;
					SDL_RenderCopyEx( Renderer, Drawer, NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
					SDL_DestroyTexture(Drawer);
					
					Output= "Score: ";
					Output.append(std::to_string(Score));  
					Result=TTF_RenderText_Blended_Wrapped(gFont[1], Output.c_str(), FontC, 1000);
					Drawer=SDL_CreateTextureFromSurface(Renderer, Result);
					SDL_FreeSurface(Result);
					SDL_QueryTexture(Drawer, NULL, NULL, &Wri.w, &Wri.h);
					Wri.x=(1920/2)-(Wri.w/2);
					Wri.y=500;
					SDL_RenderCopyEx( Renderer, Drawer, NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
					SDL_DestroyTexture(Drawer);
					
				    Output= "Name: ";
				    Output.append(eName); 
				    Output.append(abc, mSelect, 1);
					Result=TTF_RenderText_Blended_Wrapped(gFont[1], Output.c_str(), FontC, 1000);
					Drawer=SDL_CreateTextureFromSurface(Renderer, Result);
					SDL_FreeSurface(Result);
					SDL_QueryTexture(Drawer, NULL, NULL, &Wri.w, &Wri.h);
					Wri.x=(1920/2)-(Wri.w/2);
					Wri.y=600;
					SDL_RenderCopyEx( Renderer, Drawer, NULL, &Wri, NULL, NULL, SDL_FLIP_NONE); 
					SDL_DestroyTexture(Drawer);
					
					Output= "- to delete, + to confirm.";
					Result=TTF_RenderText_Blended_Wrapped(gFont[1], Output.c_str(), FontC, 1000);
					Drawer=SDL_CreateTextureFromSurface(Renderer, Result);
					SDL_FreeSurface(Result);
					SDL_QueryTexture(Drawer, NULL, NULL, &Wri.w, &Wri.h);
					Wri.x=(1920/2)-(Wri.w/2);
					Wri.y=700;
					SDL_RenderCopyEx( Renderer, Drawer, NULL, &Wri, NULL, NULL, SDL_FLIP_NONE); 
					SDL_DestroyTexture(Drawer);
				}
			
				
			}
				
				
			 SDL_RenderPresent( Renderer );
			 
		
	
}

SDL_Rect Intersect(int x, int y, Object b) //SDL_Rect Intersect(int x, int y, Object b)
{
	int x1 = Maximum((float)x-20, (float)b.X);
	int y1 = Maximum((float)y, (float)b.Y);
	int y2 = Minimum((float)y+80, (float)b.Y+b.h);
	int x2 = Minimum((float)x, (float)b.X+b.w);
	
	if(P1.POb.Speed>0)
	{
	 x1 = Maximum((float)x+50, (float)b.X);
	 y1 = Maximum((float)y, (float)b.Y);
	 y2 = Minimum((float)y+80, (float)b.Y+b.h);
	 x2 = Minimum((float)x+70, (float)b.X+b.w);
		
	}

	int w=x2-x1;
	int h=y2-y1;
	if(w>0 && h>0)
		{
			SDL_Rect r = {x1, y1, w, h};
			return r;
		}
		else
		{
			SDL_Rect r = {0, 0, 0, 0};
			return r;
		}
}

SDL_Rect Intersect2(int x, int y, Object b) //SDL_Rect Intersect(int x, int y, Object b)
{
	int x1 = Maximum((float)x, (float)b.X);
	int y1 = Maximum((float)y, (float)b.Y);
	int y2 = Minimum((float)y+90, (float)b.Y+b.h);
	int x2 = Minimum((float)x+100, (float)b.X+b.w);

	int w=x2-x1;
	int h=y2-y1;
	if(w>0 && h>0)
		{
			SDL_Rect r = {x1, y1, w, h};
			return r;
		}
		else
		{
			SDL_Rect r = {0, 0, 0, 0};
			return r;
		}
}

SDL_Rect IntersectFloor(int x, int y, Object b) //SDL_Rect Intersect(int x, int y, Object b)
{
	int x1 = Maximum((float)x, (float)b.X);
	int y1 = Maximum((float)y, (float)b.Y);
	int y2 = Minimum((float)y+(20+P1.FallSpeed), (float)b.Y+b.h);
	int x2 = Minimum((float)x+50, (float)b.X+b.w);

	int w=x2-x1;
	int h=y2-y1;
	if(w>0 && h>0)
		{
			SDL_Rect r = {x1, y1, w, h};
			return r;
		}
		else
		{
			SDL_Rect r = {0, 0, 0, 0};
			return r;
		}
}



int PlayerCheckFloor()
{
			
			float X=P1.POb.X;
			float Y=P1.POb.Y+(90);
			bool check=false;
			
			for(int i=0; i<Floors.active+1; i++)
			{
				SDL_Rect coller=IntersectFloor(X, Y, Floors.Stack[i]);
				if(coller.w == 0 && coller.h == 0)
				{
					//No Colli
					
				}
				else
				{
					check=true;
					if(Floors.Stack[i].floorn!=0 && P1.JumpPower==0)
					{
						Score=Score+(P1.Combo*Floors.Stack[i].floorn);
						Floors.ClearFloorn(Floors.Stack[i].floorn);
						//std::cout << "score: " <<Score << std::endl;
					}
					if(P1.JumpPower==0)
					P1.POb.Y=Floors.Stack[i].Y-90;
					i=Floors.active+1;
				}
				
			}
			
	return check;
}

int PlayerCheckWall()
{
			float cAngle=((P1.POb.Angle*M_PI)/180);
			float X=P1.POb.X+(cos(cAngle)*P1.POb.Speed);
			float Y=P1.POb.Y+10+(sin(cAngle)*P1.POb.Speed);
			
			
			for(int i=0; i<Walls.active+1; i++)
			{
				SDL_Rect coller=Intersect(X, Y, Walls.Stack[i]);
				if(coller.w == 0 && coller.h == 0)
				{
					//No Colli
				}
				else
				{
					if(P1.DireLock==0)
					{
					if(P1.POb.Speed>4)
					P1.POb.Speed=P1.POb.Speed/4;
					else
					P1.POb.Speed=0;
					}
				}
				
			}
			
	
}

int PlayerCheckWall2()
{
			bool Bounce=false;
			float cAngle=((P1.POb.Angle*M_PI)/180);
			float X, Y;
			if(P1.POb.Flipped==SDL_FLIP_NONE)
			{
			 X=P1.POb.X+50;
			 Y=P1.POb.Y;
			}
			else
			{
			 X=P1.POb.X-100;
			 Y=P1.POb.Y;	
				
			}
			
			for(int i=0; i<Walls.active+1; i++)
			{
				SDL_Rect coller=Intersect2(X, Y, Walls.Stack[i]);
				if(coller.w == 0 && coller.h == 0)
				{
					//No Colli
				}
				else
				{
					if(Bounce==false)
					{
					if(P1.POb.Flipped==SDL_FLIP_NONE)
					 P1.POb.Flipped=SDL_FLIP_HORIZONTAL;
					else P1.POb.Flipped=SDL_FLIP_NONE;
					P1.POb.Speed=P1.POb.Speed*(-1.00);
					if(P1.POb.Speed>0)
					{
						Mix_PlayChannel( 1, Sounds[1], 0 );
					P1.JumpPower=P1.JumpPower+(P1.POb.Speed);
						if(P1.POb.Speed<7)P1.POb.Speed=7;
					}
					if(P1.POb.Speed<0)
					{
							Mix_PlayChannel( 1, Sounds[1], 0 );
					P1.JumpPower=P1.JumpPower+((P1.POb.Speed*(-1)));
					if(P1.POb.Speed>-7)P1.POb.Speed=-7;
					}
					if(P1.JumpPower>45)P1.JumpPower=45;
					P1.Combo=P1.Combo+1;
					CreateClone(0, 10, 0);
					Bounce=true;
					P1.DireLock=30;
					}
				
				}
				
			}
			
	
}



int ObjectLogic(void *in)
{
	 
		
		

		Renderer = SDL_CreateRenderer( Window, -1, SDL_RENDERER_ACCELERATED | SDL_RENDERER_PRESENTVSYNC ); 
		    
		
		 SDL_RenderSetLogicalSize(Renderer, 1920, 1080);
		 ScreenSurface = SDL_GetWindowSurface( Window );
		if(FullScreen==1)
			SDL_SetWindowFullscreen(Window, SDL_WINDOW_FULLSCREEN);
		if(FullScreen==2)
			SDL_SetWindowFullscreen(Window, SDL_WINDOW_BORDERLESS);
			loadImages("Liste.txt");
			     SDL_ShowCursor(SDL_DISABLE);
			     
//fonts
if( TTF_Init() == -1 ) { printf( "SDL_ttf could not initialize! SDL_ttf Error: %s\n", TTF_GetError() ); }	

	gFont[1]=TTF_OpenFont( "beon-webfont.ttf", 40 );
	gFont[2]=TTF_OpenFont( "beon-webfont.ttf", 100 );
int starter=SDL_GetTicks();
srand (time(NULL));
while(running==true)
	{
		if(RunMode==1)
		{
		Background.Manage();
		Walls.Manage();
		Enemys.Manage();
		Floors.Manage();
		Clones.Manage();
		
		P1.POb.Move();
	
		bool Grounded=false;
		if(NoFun==false)
		{
		int D=rand()%7;
		if(D==1)BGR=BGR+5;
		if(D==2 && BGR>(200-P1.Combo*3))BGR=BGR-5;
		if(D==3)BGB=BGB+5;
		if(D==4 && BGB>(200-P1.Combo*3)) BGB=BGB-5;
		if(D==5)BGG=BGG+5;
		if(D==6 && BGG>(200-P1.Combo*3))BGG=BGG-5;
		if(BGR<100)BGR=100;
		if(BGB<100)BGB=100;
		if(BGG<100)BGG=100;
		if(BGR>255)BGR=255;
		if(BGB>255)BGB=255;
		if(BGG>255)BGG=255;
		ABGR=255-BGR;
		ABGB=255-BGB;
		ABGG=255-BGG;
		}
		if(rand()%5==4)
		Recoulor(ImageC[16], BGR-15, BGB-15, BGG-15, &Images[16]);
		if(rand()%6==5)
		Recoulor(ImageC[17], BGR-100, BGB-100, BGG-100, &Images[17]);
		if(GameOver==false)
		{
		if(P1.POb.Speed!=0 || P1.JumpPower>0 || P1.FallSpeed>0)
		{
			if(P1.Combo>1)
			{
			if(P1.CloneCreate<=0)
			 {
				CreateClone(255, 5);
				P1.CloneCreate=1+(50/P1.Combo); 
			 }	
			 else
			 P1.CloneCreate--;
			 
			}
		}
		if(P1.POb.Speed!=0)
		{
			P1.POb.Framing();
			if(P1.POb.Speed>0)
			P1.POb.FrameWait=40/P1.POb.Speed;
			else
			P1.POb.FrameWait=40/(P1.POb.Speed*(-1));
			
			
		}
		if(P1.PKey[5]==true && P1.KeyLock[5]==false)
			{
				P1.JumpPress++;
			}
			else
			P1.JumpPress=0;
			

		
		if(PlayerCheckFloor()==true && P1.JumpPower==0)
		{
			if(P1.PKey[4]==false && P1.PKey[3]==false)
			{
				P1.POb.Speed=P1.POb.Speed*0.98;
				if(P1.POb.Speed<0.1)P1.POb.Speed=0;
			
			}
			if(P1.ComboTimer>0)
			{
				P1.ComboTimer--;
			}
			else P1.Combo=0;
			P1.CoyoteTime=0;
			P1.SJumpBlock=false;
			Grounded=true;
			P1.POb.Sprite=2;
			P1.DireLock=0;
			P1.FallSpeed--;
			if(P1.FallSpeed<1)P1.FallSpeed=0;
			if(P1.PKey[3]==true && P1.PKey[4]==false)
			{
				if(P1.FallSpeed>0)
				{
					P1.POb.Speed=P1.POb.Speed-(P1.FallSpeed/3);
					P1.FallSpeed=0;
				}
				P1.POb.Speed=P1.POb.Speed-P1.SpeedModSlow-(P1.Combo/10);
				if(P1.POb.Speed>0)P1.POb.Speed=P1.POb.Speed-P1.SpeedMod;
				P1.ComboCharge=P1.ComboCharge+1+(P1.Combo/25);
			}
			if(P1.PKey[4]==true && P1.PKey[3]==false)
			{
				if(P1.FallSpeed>0)
				{
					P1.POb.Speed=P1.POb.Speed+(P1.FallSpeed/3);
					P1.FallSpeed=0;
				}
				P1.POb.Speed=P1.POb.Speed+P1.SpeedModSlow+(P1.Combo/10);
				if(P1.POb.Speed<0)P1.POb.Speed=P1.POb.Speed+P1.SpeedMod;
				P1.ComboCharge=P1.ComboCharge+1+(P1.Combo/25);
			}
			
			
		}
		else
		{
			
			//std::cout << "No Floor Colli";
			if(P1.DireLock>0)P1.DireLock--;
			P1.CoyoteTime++; //if(P1.JumpPower!=0)P1.CoyoteTime++;
						if(P1.PKey[5]==true && P1.KeyLock[5]==false && P1.JumpPress<10 && (P1.POb.Speed<-1 || P1.POb.Speed>1) && P1.FallSpeed<5)
			{
			PlayerCheckWall2();	
				
			}
			if(P1.JumpPower>0 )
			{
			P1.FallSpeed=0;
			P1.ComboTimer=25;
			P1.POb.Sprite=10;

				if(P1.PKey[3]==true && P1.PKey[4]==false && (P1.DireLock<=0 || P1.POb.Flipped==SDL_FLIP_HORIZONTAL))
				{
					if(P1.POb.Speed>0)
					{
					P1.POb.Speed=P1.POb.Speed-P1.SpeedModAir;
					P1.JumpPower=P1.JumpPower+((P1.Combo/100));
						
					}
					else
					{
					P1.POb.Speed=P1.POb.Speed-(P1.SpeedModAirSlow*(1+(P1.Combo/100)));
						
						
					}
					
				}
				if(P1.PKey[4]==true && P1.PKey[3]==false && (P1.DireLock<=0 || P1.POb.Flipped==SDL_FLIP_NONE))
				{
					if(P1.POb.Speed<0)
					{
					P1.POb.Speed=P1.POb.Speed+P1.SpeedModAir;
					P1.JumpPower=P1.JumpPower+2+((P1.Combo/100));
						
					}
					else
					{
					P1.POb.Speed=P1.POb.Speed+(P1.SpeedModAirSlow*(1+(P1.Combo/100)));
						
					}
					
				}
				P1.POb.Y=P1.POb.Y-((P1.JumpPower*1.05)*(1+((P1.Combo/2)/100)));
				P1.JumpPower=P1.JumpPower-0.6;
				/* old
				P1.POb.Y=P1.POb.Y-(P1.JumpPower*1.025);
				P1.JumpPower=P1.JumpPower-0.5; */
				if(P1.JumpPower<1)P1.JumpPower=0;
				
			
			}
			if(P1.JumpPower<=0)
			{
				if(P1.PKey[3]==true && P1.PKey[4]==false)
				{
					if(P1.POb.Speed>=0)
					{
					P1.POb.Speed=P1.POb.Speed-P1.SpeedModAir;
					
					}
					else
					{
					P1.POb.Speed=P1.POb.Speed-(P1.SpeedModAirSlow*(1+(P1.Combo/100)));
						
						
					}
					
				}
				if(P1.PKey[4]==true && P1.PKey[3]==false)
				{
					if(P1.POb.Speed<=0)
					{
					P1.POb.Speed=P1.POb.Speed+P1.SpeedModAir;
					
					}
					else
					{
					P1.POb.Speed=P1.POb.Speed+(P1.SpeedModAirSlow*(1+(P1.Combo/100)));
						
					}
					
				}
			P1.POb.Sprite=11;
			
			P1.FallSpeed=P1.FallSpeed+0.5+(P1.Combo/100);
			if(P1.FallSpeed>35)P1.FallSpeed=35;
			
			P1.POb.Y=P1.POb.Y+P1.FallSpeed;
			/* old
			 * 		P1.FallSpeed=P1.FallSpeed+0.3;
			if(P1.FallSpeed>20)P1.FallSpeed=20;*/
			}
			if(P1.PKey[2]==true && (P1.JumpPower>0 || P1.FallSpeed<10+P1.Combo))
			{
			P1.JumpPower=0;
			P1.FallSpeed=10+P1.Combo;
				
			}
			if(P1.PKey[1]==true && P1.Combo>1 && P1.SJumpBlock==false)
			{
			P1.JumpPower=P1.JumpPower+((P1.Combo/2)*5);
				Mix_PlayChannel( 1, Sounds[1], 0 );
			P1.Combo=P1.Combo/2;
			P1.FallSpeed=0;
			P1.SJumpBlock=true;
				
			}
			
		}
		if(P1.PKey[5]==true && P1.KeyLock[5]==false && P1.JumpPress<10 && (Grounded==true || P1.CoyoteTime<20)) //P1.CoyoteTime<5
			{
				if(P1.ComboCharge>=10)
				{
				P1.Combo++;
				P1.ComboCharge=0;
				//CreateClone(0, 10, 0);
				}
				else
				P1.ComboCharge=0;
					Mix_PlayChannel( 1, Sounds[1], 0 );
				//std::cout << "Combo: " << P1.Combo << std::endl;
				if(P1.POb.Speed>0)
				P1.JumpPower=17+(P1.Combo*1.25)+(P1.POb.Speed*0.33);
				else
				P1.JumpPower=17+(P1.Combo*1.25)-(P1.POb.Speed*0.33);
				P1.POb.Speed=P1.POb.Speed*0.77;
				P1.JumpPress=15;
			}
		PlayerCheckWall();
				if(P1.PKey[3]==true && P1.DireLock==0)
		{
			P1.POb.Flipped=SDL_FLIP_HORIZONTAL;
		}
		if(P1.PKey[4]==true && P1.DireLock==0)
		{
			P1.POb.Flipped=SDL_FLIP_NONE;
			
		}
		}
		else
		{
			//GameOver-Logic
			if(ScorePlace==0)
			{
			if(P1.PKey[1]==true && P1.KeyLock[1]==false)
		{
			P1.KeyLock[1]=true;
			mSelect--;
			if(mSelect<1)mSelect=2;
		}
				if(P1.PKey[2]==true  && P1.KeyLock[2]==false)
		{
			P1.KeyLock[2]=true;
			mSelect++;
			if(mSelect>2)mSelect=1;
		}
		if(P1.PKey[5]==true  && P1.KeyLock[5]==false && mSelect==1)
		{
			P1.KeyLock[5]=true;
			P1.PKey[5]=false;
			Restart();
		}
			if(P1.PKey[5]==true  && P1.KeyLock[5]==false && mSelect==2)
		{
			P1.KeyLock[5]=true;
			P1.PKey[5]=false;
			RunMode=0;
			mSelect=1;
			 Mix_HaltMusic();
			
		}
		}
		else
		{
			
			if(P1.PKey[1]==true && P1.KeyLock[1]==false)
		{
			P1.KeyLock[1]=true;
			mSelect--;
			if(mSelect<0)mSelect=38;
		}
				if(P1.PKey[2]==true  && P1.KeyLock[2]==false)
		{
			P1.KeyLock[2]=true;
			mSelect++;
			if(mSelect>38)mSelect=0;
		}
		if(P1.PKey[5]==true  && P1.KeyLock[5]==false)
		{
			P1.KeyLock[5]=true;
			P1.PKey[5]=false;
			if(mSelect<37)
			eName.append(abc, mSelect, 1);
			if(mSelect==37)
			{
				if(eName.size () > 0) 
				eName.pop_back();
			}
			if(mSelect==38)
			{
				Scores.EnterScore(Score, ScorePlace, eName); 
				ScorePlace=0;
				mSelect=1;
			}
		}
			
		}
			
		}
		if(P1.POb.Y>CamY+2040 && GameOver==false){ScorePlace=Scores.rPlace(Score); Scroller=0; GameOver=true; mSelect=1;   Mix_HaltMusic();} //
		starter=SDL_GetTicks()-starter;
		if(starter<15)SDL_Delay(15-starter);
		starter=SDL_GetTicks();
		CamX=410;
		if(CamY>(P1.POb.Y-(1080/2)+(250+(Scroller*15))) && GameOver==false)
		CamY=P1.POb.Y-(1080/2)+(250+(Scroller*15));
		
		if(GameOver==false);
		CamY=CamY-Scroller;
	
		if(CamY<TowerHeight+300)
		{
			if(Scroller<2)
			Scroller=Scroller+1;
			else if(Scroller<10)
			Scroller=Scroller+0.0625;
			else
			Scroller=Scroller*1.001;
			if(Scroller>10)Walled=false;
			if(Scroller>=2)
			{
				for(int i=0; i<1+(Scroller/4); i++)
				{
				int ra=rand()%6;
				    if(ra<2)Scroller=Scroller+0.05;
					else if((ra==2 || ra==3) && minL>2)minL--;
					else if(ra==4 && (maxL>2) && (minL==2 || minL+2<maxL))maxL--;
					else if(ra==5)maxD++;
					
					if(maxL<minL)maxL=minL;
					/*				
				if(ra<2)std::cout << "Scroll inceased" << Scroller << std::endl;
				if(ra==2 || ra==3)std::cout << "minL decreased" << minL << std::endl;
				if(ra==4)std::cout << "maxL decreased" << maxL << std::endl;
				if(ra==5)std::cout << "maxD decreased"  << maxD << std::endl; */
				}
				}
			//std::cout << "OOB" << std::endl;
			int s=TowerHeight;
				Object Ob;
				Ob.Sprite=5;
				Ob.w=100;
				Ob.h=100;
				Ob.X=510;
				
				if(Walled==true)
				{
				for(int i=0; i<15; i++)
				{
				Ob.Sprite=5;
				Ob.w=100;
				Ob.h=100;
				Ob.X=510;
				Ob.Y=s-(i*100);
				Ob.DrawAnti=true;
				Walls.Create(Ob);
				
				Ob.Sprite=5;
				Ob.w=100;
				Ob.h=100;
				Ob.X=2110;
				Ob.Y=s-(i*100);
				Walls.Create(Ob);
				
				BGObject c;
				c.DarkerThanBG=50-(rand()%10);
				c.w=1500;
				c.h=100;
				c.X=610;
				c.Y=s-(i*100);
				c.CamMove=true;
				c.Layer=3;
				Background.Create(c);
				
				
				
				}
				}
				for(int i2=0; i2<10; i2++)
				{
				floorC++;
				int l=1+(rand()%maxL);
				if(l<minL)l=minL;
				int r=rand()%(16-maxL);
				if(r>lastS && r-lastS>maxD)r=lastS+maxD;
				else if(r<lastS && lastS-r>maxD)r=lastS-maxD;
				lastS=r;
				for(int i=0; i<l; i++)
				{
					Ob.Sprite=13;
					Ob.h=10;
					Ob.X=610+(r*100)+(i*100);
					Ob.Y=s-(i2*150);
					Ob.DrawAnti=true;
					Ob.floorn=floorC;
					TowerHeight=s-(i2*150);
					Floors.Create(Ob);
					
					if(rand()%100<20 && Walled==true)
					{
					BGObject c;
					c.DarkerThanBG=0;
					c.Sprite=17;
					c.NoReco=true;
					c.w=50;
					c.h=80;
					c.X=610+(r*100)+(i*100)+25;
					c.Y=s-(i2*150)-110;
					c.CamMove=true;
					c.Layer=4;
					Background.Create(c);
					
					}
					
				}
				}
			
		}
		GraphicHandler();
	}
	if(RunMode==0)
	{
		if(P1.PKey[1]==true && P1.KeyLock[1]==false)
		{
			P1.KeyLock[1]=true;
			mSelect--;
			if(mSelect<1)mSelect=5;
		}
				if(P1.PKey[2]==true  && P1.KeyLock[2]==false)
		{
			P1.KeyLock[2]=true;
			mSelect++;
			if(mSelect>5)mSelect=1;
		}
		if(P1.PKey[6]==true && P1.KeyLock[6]==false)
		{
			P1.KeyLock[6]=true;
			mSelect--;
			if(mSelect<1)mSelect=5;
		}
		if(P1.PKey[7]==true  && P1.KeyLock[7]==false)
		{
			P1.KeyLock[7]=true;
			mSelect++;
			if(mSelect>7)mSelect=1;
		}
		if(P1.PKey[5]==true  && P1.KeyLock[5]==false && mSelect==1)
		{
			P1.KeyLock[5]=true;
			P1.PKey[5]=false;
			RunMode=1;
			Restart();
		}
		if(P1.PKey[5]==true  && P1.KeyLock[5]==false && mSelect==2)
		{
			P1.KeyLock[5]=true;
			P1.PKey[5]=false;
			RunMode=2;
			mSelect=1;
			
		}
		if(P1.PKey[5]==true  && P1.KeyLock[5]==false && mSelect==3)
		{
			P1.KeyLock[5]=true;
			P1.PKey[5]=false;
			RunMode=3;
			mSelect=1;
			
		}
		if(P1.PKey[5]==true  && P1.KeyLock[5]==false && mSelect==4)
		{
			P1.KeyLock[5]=true;
			P1.PKey[5]=false;
			RunMode=4;
			mSelect=1;
		}
		if(P1.PKey[5]==true  && P1.KeyLock[5]==false && mSelect==5)
		{
			P1.KeyLock[5]=true;
			P1.PKey[5]=false;
			running=false;
		}
		
		if(P1.PKey[8]==true  && P1.KeyLock[8]==false && mSelect==1)
		{
			P1.KeyLock[8]=true;
			P1.PKey[8]=false;
			RunMode=1;
			Restart();
		}
		if(P1.PKey[8]==true  && P1.KeyLock[8]==false && mSelect==2)
		{
			P1.KeyLock[8]=true;
			P1.PKey[8]=false;
			RunMode=2;
			mSelect=1;
			
		}
		if(P1.PKey[8]==true  && P1.KeyLock[8]==false && mSelect==3)
		{
			P1.KeyLock[8]=true;
			P1.PKey[8]=false;
			RunMode=3;
			mSelect=1;
			
		}
		if(P1.PKey[8]==true  && P1.KeyLock[8]==false && mSelect==4)
		{
			P1.KeyLock[8]=true;
			P1.PKey[8]=false;
			RunMode=4;
			mSelect=1;
		}
		if(P1.PKey[8]==true  && P1.KeyLock[8]==false && mSelect==5)
		{
			P1.KeyLock[8]=true;
			P1.PKey[8]=false;
			running=false;
		}
		SDL_Surface* Result=NULL;
		if(mSelect==1) Result=TTF_RenderText_Blended_Wrapped(gFont[1], "|> Start", FontC, 600); else
		Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Start", FontC, 600);
		FTex[1]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		if(mSelect==2) Result=TTF_RenderText_Blended_Wrapped(gFont[1], "|> Options", FontC, 600); else
		Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Options", FontC, 600);
		FTex[2]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		if(mSelect==3) Result=TTF_RenderText_Blended_Wrapped(gFont[1], "|> Highscores", FontC, 600); else
		Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Highscores", FontC, 600);
		FTex[3]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		if(mSelect==4) Result=TTF_RenderText_Blended_Wrapped(gFont[1], "|> Help", FontC, 600); else
		Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Help", FontC, 600);
		FTex[4]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		if(mSelect==5) Result=TTF_RenderText_Blended_Wrapped(gFont[1], "|> Quit", FontC, 600); else
		Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Quit", FontC, 600);
		FTex[5]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		
		SDL_SetRenderDrawColor(Renderer, 0, 0, 0, 255);
		SDL_RenderClear( Renderer );
		
		
			//Weißer BG, später öndern :3
			SDL_SetRenderDrawColor(Renderer, 255, 255, 255, 255);
			SDL_Rect FillerFee;
			FillerFee.x=0;
			FillerFee.y=0;
			FillerFee.w=1920;
			FillerFee.h=1080;
		SDL_RenderFillRect(Renderer, &FillerFee);
		
		SDL_Rect Wri;

		SDL_QueryTexture(FTex[1], NULL, NULL, &Wri.w, &Wri.h);
		Wri.x=1920/2-(100);
		Wri.y=300;
		SDL_RenderCopyEx( Renderer, FTex[1], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		Wri.y=400;
		SDL_QueryTexture(FTex[2], NULL, NULL, &Wri.w, &Wri.h);
		SDL_RenderCopyEx( Renderer, FTex[2], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		Wri.y=500;
		SDL_QueryTexture(FTex[3], NULL, NULL, &Wri.w, &Wri.h);
		SDL_RenderCopyEx( Renderer, FTex[3], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		Wri.y=600;
		SDL_QueryTexture(FTex[4], NULL, NULL, &Wri.w, &Wri.h);
		SDL_RenderCopyEx( Renderer, FTex[4], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		Wri.y=700;
		SDL_QueryTexture(FTex[5], NULL, NULL, &Wri.w, &Wri.h);
		SDL_RenderCopyEx( Renderer, FTex[5], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		
		SDL_RenderPresent( Renderer );
		
		for(int i=0; i<24; i++)
		{
			if(FTex[i]!=NULL)
			SDL_DestroyTexture(FTex[i]);
		}
				starter=SDL_GetTicks()-starter;
		if(starter<15)SDL_Delay(15-starter);
		starter=SDL_GetTicks();
	}
	
	if(RunMode==2)
	{
		if(InputDef==false)
		{
		if(P1.PKey[1]==true && P1.KeyLock[1]==false)
		{
			P1.KeyLock[1]=true;
			mSelect--;
			if(mSelect<1)mSelect=8;
		}
				if(P1.PKey[2]==true  && P1.KeyLock[2]==false)
		{
			P1.KeyLock[2]=true;
			mSelect++;
			if(mSelect>8)mSelect=1;
		}
		if(P1.PKey[6]==true && P1.KeyLock[6]==false)
		{
			P1.KeyLock[6]=true;
			mSelect--;
			if(mSelect<1)mSelect=8;
		}
				if(P1.PKey[7]==true  && P1.KeyLock[7]==false)
		{
			P1.KeyLock[7]=true;
			mSelect++;
			if(mSelect>8)mSelect=1;
		}
		if(P1.PKey[5]==true  && P1.KeyLock[5]==false && mSelect==1)
		{
			P1.KeyLock[5]=true;
			P1.PKey[5]=false;
			if(NoFun==true)
			 NoFun=false;
			 else NoFun=true;
		}
		if(P1.PKey[5]==true  && P1.KeyLock[5]==false && mSelect==2)
		{
			P1.KeyLock[5]=true;
			P1.PKey[5]=false;
			FullScreen++;
			if(FullScreen==3)FullScreen=0;	
		}
		if(P1.PKey[5]==true  && P1.KeyLock[5]==false && mSelect==3)
		{
			P1.KeyLock[5]=true;
			P1.PKey[5]=false;
			MusicVol++;
			if(MusicVol>12)MusicVol=0;
		}
		if(P1.PKey[5]==true  && P1.KeyLock[5]==false && mSelect==4)
		{
			P1.KeyLock[5]=true;
			P1.PKey[5]=false;
			SoundVol++;
			if(SoundVol>12)SoundVol=0;
			Mix_Volume(-1, SoundVol*10);
		}
		if(P1.PKey[5]==true  && P1.KeyLock[5]==false && mSelect==5)
		{
			P1.KeyLock[5]=true;
			P1.PKey[5]=false;
			CMode++;
			if(CMode>1)CMode=0;
		}
		if(P1.PKey[5]==true  && P1.KeyLock[5]==false && mSelect==6)
		{
			P1.KeyLock[5]=true;
			P1.PKey[5]=false;
			InputDef=true;
		}
		if(P1.PKey[5]==true  && P1.KeyLock[5]==false && mSelect==7)
		{
			P1.KeyLock[5]=true;
			P1.PKey[5]=false;
			
			if(Mono==0)Mono=1;
			else Mono=0;
		}
		if(P1.PKey[5]==true  && P1.KeyLock[5]==false && mSelect==8)
		{
			P1.KeyLock[5]=true;
			P1.PKey[5]=false;
			WriteSettings();
			RunMode=0;
			mSelect=1;
		}
		if(P1.PKey[8]==true  && P1.KeyLock[8]==false && mSelect==1)
		{
			P1.KeyLock[8]=true;
			P1.PKey[8]=false;
			if(NoFun==true)
			 NoFun=false;
			 else NoFun=true;
		}
		if(P1.PKey[8]==true  && P1.KeyLock[8]==false && mSelect==2)
		{
			P1.KeyLock[8]=true;
			P1.PKey[8]=false;
			FullScreen++;
			if(FullScreen==3)FullScreen=0;	
		}
		if(P1.PKey[8]==true  && P1.KeyLock[8]==false && mSelect==3)
		{
			P1.KeyLock[8]=true;
			P1.PKey[8]=false;
			MusicVol++;
			if(MusicVol>12)MusicVol=0;
		}
		if(P1.PKey[8]==true  && P1.KeyLock[8]==false && mSelect==4)
		{
			P1.KeyLock[8]=true;
			P1.PKey[8]=false;
			SoundVol++;
			if(SoundVol>12)SoundVol=0;
			Mix_Volume(-1, SoundVol*10);
		}
		if(P1.PKey[8]==true  && P1.KeyLock[8]==false && mSelect==5)
		{
			P1.KeyLock[8]=true;
			P1.PKey[8]=false;
			CMode++;
			if(CMode>1)CMode=0;
		}
		if(P1.PKey[8]==true  && P1.KeyLock[8]==false && mSelect==6)
		{
			P1.KeyLock[8]=true;
			P1.PKey[8]=false;
			InputDef=true;
		}
		if(P1.PKey[8]==true  && P1.KeyLock[8]==false && mSelect==7)
		{
			P1.KeyLock[8]=true;
			P1.PKey[8]=false;
			
			if(Mono==0)Mono=1;
			else Mono=0;
		}
		if(P1.PKey[8]==true  && P1.KeyLock[8]==false && mSelect==8)
		{
			P1.KeyLock[8]=true;
			P1.PKey[8]=false;
			WriteSettings();
			RunMode=0;
			mSelect=1;
		}
		}
		SDL_Surface* Result=NULL;
		if(mSelect==1) Result=TTF_RenderText_Blended_Wrapped(gFont[1], "|> Grey Mode", FontC, 600); else
		Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Grey Mode", FontC, 600);
		FTex[1]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		if(mSelect==2) Result=TTF_RenderText_Blended_Wrapped(gFont[1], "|> Fullscreen", FontC, 600); else
		Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Fullscreen", FontC, 600);
		FTex[2]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		if(mSelect==3) Result=TTF_RenderText_Blended_Wrapped(gFont[1], "|> Music Vol", FontC, 600); else
		Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Music Vol", FontC, 600);
		FTex[3]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		if(mSelect==4) Result=TTF_RenderText_Blended_Wrapped(gFont[1], "|> Sound Vol", FontC, 600); else
		Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Sound Vol", FontC, 600);
		FTex[4]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		if(mSelect==5) Result=TTF_RenderText_Blended_Wrapped(gFont[1], "|> Controll Mode", FontC, 600); else
		Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Controll Mode", FontC, 600);
		FTex[5]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		if(mSelect==6) Result=TTF_RenderText_Blended_Wrapped(gFont[1], "|> Def. Controlls", FontC, 600); else
		Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Def. Controlls", FontC, 600);
		FTex[6]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		if(mSelect==7) Result=TTF_RenderText_Blended_Wrapped(gFont[1], "|> Force Mono", FontC, 600); else
		Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Force Mono", FontC, 600);
		FTex[7]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		if(mSelect==8) Result=TTF_RenderText_Blended_Wrapped(gFont[1], "|> Back", FontC, 600); else
		Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Back", FontC, 600);
		FTex[8]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		
		if(NoFun==0)Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Off", FontC, 600);
		if(NoFun==1)Result=TTF_RenderText_Blended_Wrapped(gFont[1], "On", FontC, 600);
		
		FTex[9]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		if(FullScreen==1)Result=TTF_RenderText_Blended_Wrapped(gFont[1], "On", FontC, 600);
		else if(FullScreen==0) Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Off", FontC, 600);
		else if(FullScreen==2) Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Bordlerless", FontC, 600);
		FTex[10]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		strin=" ";
		for(int i=0; i<MusicVol; i++)
		strin.append("I");
		Result=TTF_RenderText_Blended_Wrapped(gFont[1], strin.c_str(), FontC, 600);
		FTex[11]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		strin=" ";
		for(int i=0; i<SoundVol; i++)
		strin.append("I");
		Result=TTF_RenderText_Blended_Wrapped(gFont[1], strin.c_str(), FontC, 600);
		FTex[12]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		if(CMode==0)Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Keyboard", FontC, 600);
		else Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Gamepad", FontC, 600);
		FTex[13]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
	
		if(InputDef==1)
		{
			if(CMode==0)
			{	
			if(InN==1)Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Up", FontC, 600);
			if(InN==2)Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Down", FontC, 600);
			if(InN==3)Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Left", FontC, 600);
			if(InN==4)Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Right", FontC, 600);
			if(InN==5)Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Jump", FontC, 600);
			}
			else
			{
			if(InN==1)Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Jump", FontC, 600);
				
			}
			
		}
		
		else Result=TTF_RenderText_Blended_Wrapped(gFont[1], " ", FontC, 600);
		FTex[14]=SDL_CreateTextureFromSurface(Renderer, Result);
		
		SDL_FreeSurface( Result );
		
		if(Mono==1)Result=TTF_RenderText_Blended_Wrapped(gFont[1], "On", FontC, 600);
		else if(Mono==0) Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Off", FontC, 600);
		FTex[15]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		
		SDL_SetRenderDrawColor(Renderer, 0, 0, 0, 255);
		SDL_RenderClear( Renderer );
		
		
			//Weißer BG, später öndern :3
			SDL_SetRenderDrawColor(Renderer, 255, 255, 255, 255);
			SDL_Rect FillerFee;
			FillerFee.x=0;
			FillerFee.y=0;
			FillerFee.w=1920;
			FillerFee.h=1080;
		SDL_RenderFillRect(Renderer, &FillerFee);
		
		SDL_Rect Wri;

		SDL_QueryTexture(FTex[1], NULL, NULL, &Wri.w, &Wri.h);
		Wri.x=400;
		Wri.y=200;
		SDL_RenderCopyEx( Renderer, FTex[1], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		Wri.y=300;
		SDL_QueryTexture(FTex[2], NULL, NULL, &Wri.w, &Wri.h);
		SDL_RenderCopyEx( Renderer, FTex[2], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		Wri.y=400;
		SDL_QueryTexture(FTex[3], NULL, NULL, &Wri.w, &Wri.h);
		SDL_RenderCopyEx( Renderer, FTex[3], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		Wri.y=500;
		SDL_QueryTexture(FTex[4], NULL, NULL, &Wri.w, &Wri.h);
		SDL_RenderCopyEx( Renderer, FTex[4], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		Wri.y=600;
		SDL_QueryTexture(FTex[5], NULL, NULL, &Wri.w, &Wri.h);
		SDL_RenderCopyEx( Renderer, FTex[5], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		Wri.y=700;
		SDL_QueryTexture(FTex[6], NULL, NULL, &Wri.w, &Wri.h);
		SDL_RenderCopyEx( Renderer, FTex[6], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		Wri.y=800;
		SDL_QueryTexture(FTex[7], NULL, NULL, &Wri.w, &Wri.h);
		SDL_RenderCopyEx( Renderer, FTex[7], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		
		Wri.y=900;
		SDL_QueryTexture(FTex[8], NULL, NULL, &Wri.w, &Wri.h);
		SDL_RenderCopyEx( Renderer, FTex[8], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		
		SDL_QueryTexture(FTex[9], NULL, NULL, &Wri.w, &Wri.h);
		Wri.x=800;
		Wri.y=200;
		SDL_RenderCopyEx( Renderer, FTex[9], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		Wri.y=300;
		SDL_QueryTexture(FTex[10], NULL, NULL, &Wri.w, &Wri.h);
		SDL_RenderCopyEx( Renderer, FTex[10], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		Wri.y=400;
		SDL_QueryTexture(FTex[11], NULL, NULL, &Wri.w, &Wri.h);
		SDL_RenderCopyEx( Renderer, FTex[11], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		Wri.y=500;
		SDL_QueryTexture(FTex[12], NULL, NULL, &Wri.w, &Wri.h);
		SDL_RenderCopyEx( Renderer, FTex[12], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		Wri.y=600;
		SDL_QueryTexture(FTex[13], NULL, NULL, &Wri.w, &Wri.h);
		SDL_RenderCopyEx( Renderer, FTex[13], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		Wri.y=700;
		SDL_QueryTexture(FTex[14], NULL, NULL, &Wri.w, &Wri.h);
		SDL_RenderCopyEx( Renderer, FTex[14], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		Wri.y=800;
		SDL_QueryTexture(FTex[15], NULL, NULL, &Wri.w, &Wri.h);
		SDL_RenderCopyEx( Renderer, FTex[15], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		
		SDL_RenderPresent( Renderer );
				for(int i=0; i<24; i++)
		{
			if(FTex[i]!=NULL)
			SDL_DestroyTexture(FTex[i]);
		}
		
				starter=SDL_GetTicks()-starter;
		if(starter<15)SDL_Delay(15-starter);
		starter=SDL_GetTicks();
	}
	if(RunMode==3)
	{
		if(P1.PKey[5]==true  && P1.KeyLock[5]==false )
		{
			P1.KeyLock[5]=true;
			P1.PKey[5]=false;
			RunMode=0;
			mSelect=1;
		}
			if(P1.PKey[8]==true  && P1.KeyLock[8]==false )
		{
			P1.KeyLock[8]=true;
			P1.PKey[8]=false;
			RunMode=0;
			mSelect=1;
		}
		
		
		SDL_SetRenderDrawColor(Renderer, 0, 0, 0, 255);
		SDL_RenderClear( Renderer );
		
		
			//Weißer BG, später öndern :3
			SDL_SetRenderDrawColor(Renderer, 255, 255, 255, 255);
			SDL_Rect FillerFee;
			FillerFee.x=0;
			FillerFee.y=0;
			FillerFee.w=1920;
			FillerFee.h=1080;
		SDL_RenderFillRect(Renderer, &FillerFee);
		
		SDL_Rect Wri;

		Scores.Draw(Renderer);
		
		SDL_RenderPresent( Renderer );
				for(int i=0; i<24; i++)
		{
			if(FTex[i]!=NULL)
			SDL_DestroyTexture(FTex[i]);
		}
		
				starter=SDL_GetTicks()-starter;
		if(starter<15)SDL_Delay(15-starter);
		starter=SDL_GetTicks();
	}
	if(RunMode==4)
	{
		if(P1.PKey[5]==true  && P1.KeyLock[5]==false )
		{
			P1.KeyLock[5]=true;
			P1.PKey[5]=false;
			RunMode=0;
			
		}
				if(P1.PKey[8]==true  && P1.KeyLock[8]==false )
		{
			P1.KeyLock[8]=true;
			P1.PKey[8]=false;
			RunMode=0;
			
		}
		
		
		SDL_SetRenderDrawColor(Renderer, 0, 0, 0, 255);
		SDL_RenderClear( Renderer );
		
		
			//Weißer BG, später öndern :3
			SDL_SetRenderDrawColor(Renderer, 255, 255, 255, 255);
			SDL_Rect FillerFee;
			FillerFee.x=0;
			FillerFee.y=0;
			FillerFee.w=1920;
			FillerFee.h=1080;
		SDL_RenderFillRect(Renderer, &FillerFee);
		
		SDL_Rect Wri;

		SDL_Surface* Result=NULL;
		Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Seeing the state of the world, you decided that you want to punch the creator of existence himself on the nose. To do so, you need to climb the Tower of Infinity. \n \n Use the \"Left/Right\" buttons to move.\n \nUse the \"Jump\" button to jump.\n \nSwitching your direction while being mid-air increases your jumping height.\n \nYou can chain a combo. To do so, run for a short time between jumps.\n\nA higher combo increases your jumping power and point multiplier.\n\nUse the \"Jump\" button mid-air against a wall to perform a walljump. This move also increases your combo.\n\nUse the \"Down\" button to stop a jumping mid-air and stomp to the ground.\n\nUse the \"Up\" button mid-air to perform a save at the cost of half of your combo.\n\nGood luck! ", FontC, 1820);
		FTex[1]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		SDL_QueryTexture(FTex[1], NULL, NULL, &Wri.w, &Wri.h);
		Wri.x=50;
		Wri.y=50;
		SDL_RenderCopyEx( Renderer, FTex[1], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		
		SDL_RenderPresent( Renderer );
				for(int i=0; i<24; i++)
		{
			if(FTex[i]!=NULL)
			SDL_DestroyTexture(FTex[i]);
		}
		
				starter=SDL_GetTicks()-starter;
		if(starter<15)SDL_Delay(15-starter);
		starter=SDL_GetTicks();
	}
	if(RunMode==10)
	{
				TimeIn++;
		if(TimeIn==1)
		Mix_PlayChannel( 1, Sounds[2], 0 );
		if(P1.PKey[5]==true  && P1.KeyLock[5]==false && TimeIn>400)
		{
			P1.KeyLock[5]=true;
			P1.PKey[5]=false;
			RunMode=11;
			Mix_FadeInMusic(Music[9], 1, 100);
			//Create Intro
					 BGObject m;
					 m.Sprite=14;
					 m.w=150;
					 m.h=150;
					 m.X=100+(rand()%150);
					 m.Y=100+(rand()%150);
					 m.Layer=1;
					 Background.Create(m);
					 BGObject ground;
			
							BGObject star;
					for(int i=0; i<(100+(rand()%500)); i++)
					{
						int si=rand()%5;
						star.w=4+si;
						star.h=4+si;
						star.Sprite=1;
						star.X=0+rand()%1920;
						star.Y=0+rand()%1080;
						star.Layer=1;
						star.DarkerThanBG=5+rand()%60;
						Background.Create(star);
					}
					
			
			ground.Sprite=1;
			ground.X=0;
			ground.Y=810;
			ground.h=600;
			ground.w=1920;
			ground.Layer=4;
			ground.DarkerThanBG=130;
			Background.Create(ground);
					 float Speed=-2+(rand()%4);
					 Speed=Speed+((rand()%100)/100);
				
					 
					  for(int i=0; i<150+(rand()%200); i++)
					 {
							m.Sprite=16; 
							m.w=220;
							m.h=150;
							m.X=0+(rand()%2100);
							m.Y=-1000+(rand()%2000);
							m.maxX=2500;
							m.minX=-1500;
							m.Angle=270;
							m.Zoomed=(float)0.5+(rand()%100/50);
							m.ZoomPT=0.0025;
							m.Speed=3;
							m.Layer=3;
							if(rand()%3>1)m.Flipped=SDL_FLIP_HORIZONTAL;
							else m.Flipped=SDL_FLIP_NONE;
							m.NoReco=true;
							Background.Create(m);
						 
					 }
			
			//Intro End
			TimeIn=0;
		}

		SDL_SetRenderDrawColor(Renderer, 0, 0, 0, 255);
		SDL_RenderClear( Renderer );
		
		
			//Weißer BG, später öndern :3
			SDL_SetRenderDrawColor(Renderer, 255, 255, 255, 255);
			SDL_Rect FillerFee;
			FillerFee.x=0;
			FillerFee.y=0;
			FillerFee.w=1920;
			FillerFee.h=1080;
		SDL_RenderFillRect(Renderer, &FillerFee);
		
		SDL_Rect Wri;
		if(TimeIn<300)
		{
		SDL_QueryTexture(Images[7], NULL, NULL, &Wri.w, &Wri.h);
		Wri.x=1920/2-(Wri.w/2);
		Wri.y=200;
		SDL_RenderCopyEx( Renderer, Images[7], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);	
		SDL_Surface* Result=NULL;
		Result=TTF_RenderText_Blended_Wrapped(gFont[2], "ThunderPerfectWitchcraft 2021", FontC, 1820);
		FTex[1]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		SDL_QueryTexture(FTex[1], NULL, NULL, &Wri.w, &Wri.h);
		Wri.x=1920/2-(Wri.w/2);
		Wri.y=700;
		SDL_RenderCopyEx( Renderer, FTex[1], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		}
		if(TimeIn>300)
		{
		SDL_Surface* Result=NULL;
		Result=TTF_RenderText_Blended_Wrapped(gFont[2], "Epilepsy Warning", FontR, 1820);
		FTex[1]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		if(TimeIn>400)
		Result=TTF_RenderText_Blended_Wrapped(gFont[1], "This game features fast flashing colours and is not safe for people suffering from photosensitive epilepsy or similiar conditions. Press ESC to quit the game now. \n \n\n\nIt is possible to disable the flashing colours in the \"Options\" menu (\"Grey Mode\") or by pressing F10 at any time. \n \n \n \n \n \nPress \"Jump\" (the default is \"Space\") to proceed. ", FontC, 1820);
		else
		Result=TTF_RenderText_Blended_Wrapped(gFont[1], "This game features fast flashing colours and is not safe for people suffering from photosensitive epilepsy or similiar conditions. Press ESC to quit the game now.\n \n\n\nIt is possible to disable the flashing colours in the \"Options\" menu (\"Grey Mode\") or by pressing F10 at any time. \n \n", FontC, 1820);
		FTex[2]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		SDL_QueryTexture(FTex[1], NULL, NULL, &Wri.w, &Wri.h);
		Wri.x=500;
		Wri.y=50;
		SDL_RenderCopyEx( Renderer, FTex[1], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		SDL_QueryTexture(FTex[2], NULL, NULL, &Wri.w, &Wri.h);
		Wri.x=50;
		Wri.y=300;
		SDL_RenderCopyEx( Renderer, FTex[2], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		}
		SDL_RenderPresent( Renderer );
				for(int i=0; i<24; i++)
		{
			if(FTex[i]!=NULL)
			SDL_DestroyTexture(FTex[i]);
		}
		
				starter=SDL_GetTicks()-starter;
		if(starter<15)SDL_Delay(15-starter);
		starter=SDL_GetTicks();
	}
	if(RunMode==11)
	{
		if(P1.PKey[5]==true  && P1.KeyLock[5]==false && TimeIn>10)
		{
			P1.KeyLock[5]=true;
			P1.PKey[5]=false;
			Mix_HaltMusic();
			RunMode=0;
			
		}
		TimeIn++;
				if(NoFun==false)
				{
				int D=rand()%7;
				if(D==1)BGR=BGR+5;
				if(D==2 && BGR>(200-P1.Combo*3))BGR=BGR-5;
				if(D==3)BGB=BGB+5;
				if(D==4 && BGB>(200-P1.Combo*3)) BGB=BGB-5;
				if(D==5)BGG=BGG+5;
				if(D==6 && BGG>(200-P1.Combo*3))BGG=BGG-5;
				if(BGR<100)BGR=100;
				if(BGB<100)BGB=100;
				if(BGG<100)BGG=100;
				if(BGR>255)BGR=255;
				if(BGB>255)BGB=255;
				if(BGG>255)BGG=255;
				ABGR=255-BGR;
				ABGB=255-BGB;
				ABGG=255-BGG;
				}
					 if(rand()%4==3)
					 Recoulor(ImageC[16], BGR-15, BGB-15, BGG-15, &Images[16]);
					if(rand()%5==4)
					Recoulor(ImageC[17], BGR-100, BGB-100, BGG-100, &Images[17]);
					if(rand()%5==4)
					Recoulor(ImageC[3], ABGR+80, ABGB+80, ABGG+80, &Images[3]);
					if(rand()%5==4)
					Recoulor(ImageC[4], ABGR+60, ABGB+100, ABGG+20, &Images[4]);
					if(rand()%5==4)
					Recoulor(ImageC[5], ABGR+30, ABGB+50, ABGG+10, &Images[5]);
					if(rand()%5==4)
					Recoulor(ImageC[6], ABGR+30, ABGB+40, ABGG+20, &Images[6]);
					
					//recreate Clouds:
					 BGObject m;
					if(TimeIn==450)
					{
						BGObject t;
						t.Sprite=1;
						t.w=10;
						t.h=100;
						t.X=(1920/2)-5;
						t.Y=800;
						t.Layer=3;
						t.DarkerThanBG=100;
						t.ZoomPT=0.02;
						Background.Create(t);
						 float Speed=-2+(rand()%4);
					 Speed=Speed+((rand()%100)/100);
					 t.DarkerThanBG=0;
					
					 for(int i=0; i<150+(rand()%200); i++)
					 {
							m.Sprite=16; 
							m.w=220;
							m.h=150;
							m.X=-1900+(rand()%4100);
							m.Y=-100+(rand()%2000);
							m.maxX=2500;
							m.minX=-1500;
							m.Angle=0;
							m.Speed=Speed;
							m.Layer=2;
							if(rand()%3>1)m.Flipped=SDL_FLIP_HORIZONTAL;
							else m.Flipped=SDL_FLIP_NONE;
							m.NoReco=true;
							Background.Create(m);
						 
					 }
						
					}
					if(TimeIn<500)
					 for(int i=0; i<1; i++)
					 {
						m.Sprite=16; 
						m.w=220;
						m.h=150;
						m.X=-100+(rand()%2100);
						m.Y=730;
						m.maxX=2500;
						m.minX=-1500;
						m.Angle=200+(rand()%140);
						m.Speed=2;
						m.Zoomed=(float)0.1+((rand()%99)/99);
						m.ZoomPT=0.0025;
						m.Lifetime=3000;
						m.Layer=3;
						if(rand()%3>1)m.Flipped=SDL_FLIP_HORIZONTAL;
						else m.Flipped=SDL_FLIP_NONE;
						m.NoReco=true;
						Background.Create(m);
						
						m.Sprite=3; 
						m.w=100;
						m.h=200;
						m.X=-100+(rand()%2100);
						m.Y=690;
						m.maxX=2500;
						m.minX=-1500;
						m.Angle=90; //m.Angle=45+(rand()%90);
						m.Speed=6;
						m.Zoomed=(float)0.1+((rand()%200)/999);
						m.ZoomPT=0.0325;
						m.Lifetime=500;
						m.Layer=5;
						if(rand()%3>1)m.Flipped=SDL_FLIP_HORIZONTAL;
						else m.Flipped=SDL_FLIP_NONE;
						m.NoReco=true;
						Background.Create(m);
						
						m.Sprite=4; 
						m.w=300;
						m.h=200;
						m.X=-100+(rand()%2100);
						m.Y=690;
						m.maxX=2500;
						m.minX=-1500;
						m.Angle=90; 
						m.Speed=6;
						m.Zoomed=(float)0.05+((rand()%200)/999);
						m.ZoomPT=0.0325;
						m.Lifetime=500;
						m.Layer=5;
						if(rand()%3>1)m.Flipped=SDL_FLIP_HORIZONTAL;
						else m.Flipped=SDL_FLIP_NONE;
						m.NoReco=true;
						Background.Create(m);
						
						m.Sprite=5; 
						m.w=300;
						m.h=200;
						m.X=-100+(rand()%2100);
						m.Y=690;
						m.maxX=2500;
						m.minX=-1500;
						m.Angle=90; 
						m.Speed=6;
						m.Zoomed=(float)0.3+((rand()%200)/999);
						m.ZoomPT=0.0325;
						m.Lifetime=500;
						m.Layer=5;
						if(rand()%3>1)m.Flipped=SDL_FLIP_HORIZONTAL;
						else m.Flipped=SDL_FLIP_NONE;
						m.NoReco=true;
						Background.Create(m);
						
						m.Sprite=6; 
						m.w=300;
						m.h=200;
						m.X=-100+(rand()%2100);
						m.Y=690;
						m.maxX=2500;
						m.minX=-1500;
						m.Angle=90; 
						m.Speed=6;
						m.Zoomed=(float)0.2+((rand()%200)/999);
						m.ZoomPT=0.0325;
						m.Lifetime=500;
						m.Layer=5;
						if(rand()%3>1)m.Flipped=SDL_FLIP_HORIZONTAL;
						else m.Flipped=SDL_FLIP_NONE;
						m.NoReco=true;
						Background.Create(m);
						
						
						
						 
					 }
					
					
					
			SDL_Rect FillerFee;
			SDL_SetRenderDrawColor(Renderer, BGR, BGB, BGG, 255);
			Background.Manage();
			FillerFee.x=0;
			FillerFee.y=0;
			FillerFee.w=1920;
			FillerFee.h=1080;
			
			SDL_RenderFillRect(Renderer, &FillerFee);
			Background.Draw(Renderer);
			
			
				SDL_Rect Wri;

		if(TimeIn>800)
		{
		SDL_Surface* Result=NULL;
		Result=TTF_RenderText_Blended_Wrapped(gFont[2], "Acid Flight", FontR, 1820);
		FTex[1]=SDL_CreateTextureFromSurface(Renderer, Result);
		Recoulor(Result, 0+rand()%255, 0+rand()%255, 0+rand()%255, &FTex[1]);
		SDL_FreeSurface(Result);
		Result=TTF_RenderText_Blended_Wrapped(gFont[1], "SDL2 is under the zlib-license. Beon font by Bastien Sozoo, SIL Open-Font license. Thanks to Adro, CCoke, Yammel, Mace, Ossurian, NoData, and Volands_Comics for testing. Have fun playing! ThunderPerfectWitchcraft 2021 - All rights reserved.", FontC, 1820);
		FTex[2]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		
		Result=TTF_RenderText_Blended_Wrapped(gFont[1], "Press Jump to Proceed!", FontR, 1820);
		FTex[3]=SDL_CreateTextureFromSurface(Renderer, Result);
		SDL_FreeSurface(Result);
		
		SDL_QueryTexture(FTex[1], NULL, NULL, &Wri.w, &Wri.h);
		Wri.x=1920/2-(Wri.w/2);
		Wri.y=400;
		SDL_RenderCopyEx( Renderer, FTex[1], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		SDL_QueryTexture(FTex[3], NULL, NULL, &Wri.w, &Wri.h);
		Wri.x=1920/2-(Wri.w/2);
		Wri.y=500;
		SDL_RenderCopyEx( Renderer, FTex[3], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		SDL_QueryTexture(FTex[2], NULL, NULL, &Wri.w, &Wri.h);
		Wri.x=1920/2-(Wri.w/2);
		Wri.y=860;
		SDL_RenderCopyEx( Renderer, FTex[2], NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
		
		}
				for(int i=0; i<24; i++)
		{
			if(FTex[i]!=NULL)
			SDL_DestroyTexture(FTex[i]);
		}
		
				starter=SDL_GetTicks()-starter;
		if(starter<15)SDL_Delay(15-starter);
		starter=SDL_GetTicks();
			
		
		SDL_RenderPresent( Renderer );
	}
		
	
	}
	
}





int MusicMan()
{
if(RunMode==1)
{
 if(P1.POb.Y>CamY+1080 && GameOver==false)
  {
	  if(cVolume>0)cVolume=cVolume-0.1;  
  }
  else
   if(cVolume<MusicVol*10)
    cVolume=cVolume+0.1;
}
else 
   if(cVolume<MusicVol*10)
    cVolume=cVolume+0.1;
if(cVolume>0)
     Mix_VolumeMusic(cVolume);
     else
      Mix_VolumeMusic(0);

 if(Mix_PlayingMusic()==0)
   {
	   if(RunMode==1)
	   {
	   if(GameOver==false)
	   {
	  int rando=1+(rand()%6); 
	  while(rando==cSong)
	  {
		  rando=1+(rand()%6);
	  }
	   Mix_FadeInMusic(Music[rando], 1, 100);
	   cSong=rando;
		}
		else
		{
		 Mix_FadeInMusic(Music[7], 1, 100);
		}
		}
		else
		Mix_FadeInMusic(Music[8], 1, 100);
   }	
	
}

int main()
{
	srand (time(NULL));
	//Restart();
	loadSettings("Settings.txt");
	Scores.Read();
	

//end defs
	int in;
	iniSDL();
	LoadMusic();
	Mix_VolumeMusic(MusicVol*10);
	 Mix_Volume(-1, SoundVol*10);
	Sounds[1]=Mix_LoadWAV("Sounds/jump.ogg");
	Sounds[2]=Mix_LoadWAV("Sounds/laugh.ogg");
	

	int starter=SDL_GetTicks();
	SDL_Thread* Logic = SDL_CreateThread( ObjectLogic, "Logic", (void*)in);
	while(running==true)
	{
		if(RunMode!=10 && RunMode!=11)
		MusicMan();
		Events();
		
			starter=SDL_GetTicks()-starter;
			if(starter<16)SDL_Delay(16-starter);
			starter=SDL_GetTicks();
	}
	SDL_DestroyTexture(re);
}
